SET SQL DIALECT 3;
SET NAMES utf8;
CREATE DATABASE '/home/matthieu/Bureau/Matthieu/Programmation/Lazarus-Delphi/XMLFrames/demos/hotel_firebird/x86_64-linux/../w4hotel.fdb' USER 'SYSDBA' PASSWORD 'masterkey' PAGE_SIZE 16384 DEFAULT CHARACTER SET utf8;
CONNECT '/home/matthieu/Bureau/Matthieu/Programmation/Lazarus-Delphi/XMLFrames/demos/hotel_firebird/x86_64-linux/../w4hotel.fdb' USER 'SYSDBA' PASSWORD 'masterkey';
SET SQL DIALECT 3;
SET NAMES utf8;
CREATE TABLE city(
  w4hotelCityName VARCHAR(30)    ,
  w4hotelCityProvince VARCHAR(30)    ,
  w4hotelCityX INTEGER  NOT NULL  ,
  w4hotelCityY INTEGER  NOT NULL  ,
  w4hotelCityLongitude INTEGER  NOT NULL  ,
  w4hotelCityLatitude INTEGER  NOT NULL    ,
  PRIMARY KEY(w4hotelCityName));


CREATE GENERATOR city_w4hotelCityName;

SET TERM !; 
CREATE TRIGGER AINC_city FOR city BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelCityName IS NULL) THEN 
    NEW.w4hotelCityName = GEN_ID(city_w4hotelCityName, 1); 
END! 
SET TERM ;! 


GRANT ALL ON city TO PUBLIC WITH GRANT OPTION;

CREATE TABLE client(
  w4hotelClientNumber INTEGER    ,
  w4hotelClientTitle VARCHAR(1)  NOT NULL  ,
  w4hotelClientName VARCHAR(30)  NOT NULL  ,
  w4hotelClientFirstname VARCHAR(30)  NOT NULL  ,
  w4hotelClientAddress INTEGER    ,
  w4hotelClientTels VARCHAR(30)    ,
  w4hotelClientReservations INTEGER      ,
  PRIMARY KEY(w4hotelClientNumber));


CREATE GENERATOR client_w4hotelClientNumber;

SET TERM !; 
CREATE TRIGGER AINC_client FOR client BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelClientNumber IS NULL) THEN 
    NEW.w4hotelClientNumber = GEN_ID(client_w4hotelClientNumber, 1); 
END! 
SET TERM ;! 


GRANT ALL ON client TO PUBLIC WITH GRANT OPTION;

CREATE TABLE address(
  w4hotelAddressId INTEGER    ,
  w4hotelAddressStreet VARCHAR(30)  NOT NULL  ,
  w4hotelAddressZipCode VARCHAR(30)  NOT NULL  ,
  w4hotelAddressCity VARCHAR(30)      ,
  PRIMARY KEY(w4hotelAddressId));


CREATE GENERATOR address_w4hotelAddressId;

SET TERM !; 
CREATE TRIGGER AINC_address FOR address BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelAddressId IS NULL) THEN 
    NEW.w4hotelAddressId = GEN_ID(address_w4hotelAddressId, 1); 
END! 
SET TERM ;! 


GRANT ALL ON address TO PUBLIC WITH GRANT OPTION;

CREATE TABLE reservation(
  w4hotelReservationNumber INTEGER    ,
  w4hotelReservationState VARCHAR(1)  NOT NULL  ,
  w4hotelReservationDate DATE    ,
  w4hotelReservationClient INTEGER    ,
  w4hotelReservationCheckIn DATE  NOT NULL  ,
  w4hotelReservationCheckOut DATE  NOT NULL  ,
  w4hotelReservationNights INTEGER  NOT NULL  ,
  w4hotelReservationEstablishment INTEGER    ,
  w4hotelReservationRooms INTEGER    ,
  w4hotelReservationAdults INTEGER  NOT NULL  ,
  w4hotelReservationChildren INTEGER  NOT NULL    ,
  PRIMARY KEY(w4hotelReservationNumber));


CREATE GENERATOR reservation_w4hotelReservationN;

SET TERM !; 
CREATE TRIGGER AINC_reservation FOR reservation BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelReservationNumber IS NULL) THEN 
    NEW.w4hotelReservationNumber = GEN_ID(reservation_w4hotelReservationN, 1); 
END! 
SET TERM ;! 


GRANT ALL ON reservation TO PUBLIC WITH GRANT OPTION;

CREATE TABLE establishment(
  w4hotelEstablishmentId INTEGER    ,
  w4hotelEstablishmentName VARCHAR(60)    ,
  w4hotelEstablishmentCategory VARCHAR(1)  NOT NULL  ,
  w4hotelEstablishmentManager VARCHAR(30)    ,
  w4hotelEstablishmentAddress INTEGER    ,
  w4hotelEstablishmentTel VARCHAR(30)    ,
  w4hotelEstablishmentDescription VARCHAR(30)    ,
  w4hotelEstablishmentPicture VARCHAR(100)      ,
  PRIMARY KEY(w4hotelEstablishmentId));


CREATE GENERATOR establishment_w4hotelEstablishm;

SET TERM !; 
CREATE TRIGGER AINC_establishment FOR establishment BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelEstablishmentName IS NULL) THEN 
    NEW.w4hotelEstablishmentName = GEN_ID(establishment_w4hotelEstablishm, 1); 
END! 
SET TERM ;! 


GRANT ALL ON establishment TO PUBLIC WITH GRANT OPTION;

CREATE TABLE manager(
  w4hotelManagerId VARCHAR(30)    ,
  w4hotelManagerPassword VARCHAR(30)  NOT NULL  ,
  w4hotelManagerName VARCHAR(30)  NOT NULL  ,
  w4hotelManagerFirstname VARCHAR(30)  NOT NULL  ,
  w4hotelManagerPicture VARCHAR(100)    ,
  w4hotelManagerDate DATE  NOT NULL  ,
  w4hotelManagerEstablishments INTEGER      ,
  PRIMARY KEY(w4hotelManagerId));

GRANT ALL ON manager TO PUBLIC WITH GRANT OPTION;

CREATE TABLE province(
  w4hotelProvinceId VARCHAR(30)    ,
  w4hotelProvinceName VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(w4hotelProvinceId));


CREATE GENERATOR province_w4hotelProvinceId;

SET TERM !; 
CREATE TRIGGER AINC_province FOR province BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelProvinceId IS NULL) THEN 
    NEW.w4hotelProvinceId = GEN_ID(province_w4hotelProvinceId, 1); 
END! 
SET TERM ;! 


GRANT ALL ON province TO PUBLIC WITH GRANT OPTION;

CREATE TABLE room(
  w4hotelRoomId INTEGER    ,
  w4hotelRoomEstablishment INTEGER    ,
  w4hotelRoomNumber INTEGER    ,
  w4hotelRoomType VARCHAR(1)  NOT NULL  ,
  w4hotelRoomRate DECIMAL  NOT NULL  ,
  w4hotelRoomSmoking VARCHAR(1)  NOT NULL  ,
  w4hotelRoomBath VARCHAR(1)  NOT NULL  ,
  w4hotelRoomEquipments VARCHAR(1)    ,
  w4hotelRoomPicture VARCHAR(100)      ,
  PRIMARY KEY(w4hotelRoomId));


CREATE GENERATOR room_w4hotelRoomId;

SET TERM !; 
CREATE TRIGGER AINC_room FOR room BEFORE INSERT  
AS
BEGIN 
  IF (NEW.w4hotelRoomId IS NULL) THEN 
    NEW.w4hotelRoomId = GEN_ID(room_w4hotelRoomId, 1); 
END! 
SET TERM ;! 


GRANT ALL ON room TO PUBLIC WITH GRANT OPTION;

COMMIT;

