﻿unit u_import_components;

{$I ..\DLCompilers.inc}
{$I ..\extends.inc}
{$IFDEF FPC}
{$mode Delphi}
{$ENDIF}

interface

uses
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  u_filter_components;

const
    CST_IMPORT_RELATION = 'Relation';
{$IFDEF VERSIONS}
    gVer_import_components : T_Version = ( Component : 'Composants de filtrage' ;
                                               FileUnit : 'u_import_components' ;
                                               Owner : 'Matthieu Giroux' ;
                                               Comment : 'Composants d''interactivité de U_CustomFrameWork.' ;
                                               BugsStory :  '0.9.0.0 : Import components node.';
                                               UnitType : 3 ;
                                               Major : 0 ; Minor : 9 ; Release : 0 ; Build : 0 );

{$ENDIF}
type
    IImportComponent = interface
    ['{AD26CA63-FA00-447B-8311-E3F41136253D}'] // GUID nécessaire pour l'opération de cast
      End;

   { TFWFilterEdit }

   TFWImportEdit = class ( TFWFilterEdit, IImportComponent )
     private
      FRelationShip : String;
     public
      property Relation     : String     read FRelationShip write FRelationShip;
    End;


    { TFWImportSpinEdit }

    TFWImportSpinEdit = class ( TFWFilterSpinEdit, IImportComponent )
      private
       FRelationShip : String;
      public
       property Relation     : String     read FRelationShip write FRelationShip;
     End;

     { TFWImportDateEdit }

     TFWImportDateEdit = class ( TFWFilterDateEdit, IImportComponent )
       private
        FRelationShip : String;
       public
        property Relation     : String     read FRelationShip write FRelationShip;
      End;

   { TFWImportComboBox }

   TFWImportComboBox = class ( TFWFilterComboBox, IImportComponent )
     private
      FRelationShip : String;
     public
      property Relation     : String     read FRelationShip write FRelationShip;
    End;

   { TFWImportGrid }

   TFWImportGrid = class ( TFWFilterGrid, IImportComponent )
    private
     FRelationShip : String;
    public
     property Relation     : String     read FRelationShip write FRelationShip;
   End;



    { TFWImportDateTimePicker }

    TFWImportDateTimePicker = class ( TFWFilterDateTimePicker, IImportComponent )
    private
     FRelationShip : String;
    public
     property Relation     : String     read FRelationShip write FRelationShip;
      End;

    { TFWImportRadioGroup }

    TFWImportRadioGroup = class ( TFWFilterRadioGroup, IImportComponent )
       private
        FRelationShip : String;
       public
        property Relation     : String     read FRelationShip write FRelationShip;
      End;


implementation


{$IFDEF VERSIONS}
initialization
  // Gestion de version
  p_ConcatVersion(gVer_import_components);
{$ENDIF}
end.

