unit u_xmlform;


{$I ..\DLCompilers.inc}
{$I ..\extends.inc}

interface
{$IFDEF FPC}
{$mode Delphi}
{$ENDIF}

///////////////////////////////////////////////////////////////////////
// Nom Unite: U_FXMLForm
// Description : Création d'une fiche automatisée
// Créé par Matthieu GIROUX le 15/03/2009
///////////////////////////////////////////////////////////////////////

uses
 {$IFDEF FPC}
 LCLType,
 {$ELSE}
 Windows,
 {$ENDIF}
  JvXPButtons,
  Controls, Classes, DB,
  StdCtrls,
  IniFiles,
  U_ExtDBNavigator, Forms,
  ComCtrls, SysUtils,
  U_CustomFrameWork, U_OnFormInfoIni,
  fonctions_string, ALXmlDoc, fonctions_xml, ExtCtrls,
  u_xmlfillcombobutton,
  u_form_working,
  VirtualTrees,
  fonctions_dbservice,
  fonctions_manbase,
  Spin,
{$IFDEF RX}
{$ENDIF}
{$IFDEF VERSIONS}
  fonctions_version,
{$ENDIF}
  u_framework_components,
  U_ExtOperation, u_extoperate,
  u_multidata,  Menus, fonctions_ObjetsXML,
  u_man_reports_components, DBGrids,
  Graphics, U_GroupView;

{$IFDEF VERSIONS}
const

    gVer_TXMLForm : T_Version = ( Component : 'Composant TF_XMLForm' ;
                                  FileUnit  : 'U_XMLForm' ;
                                  Owner     : 'Matthieu Giroux' ;
                                  Comment   : 'Fiche personnalisée avec création de composant à partir du XML.' ;
                                  BugsStory : '0.9.7.1 : Testing uninited variables.'  + #13#10 +
                                              '0.9.7.0 : Tree and more compound actions.'  + #13#10 +
                                              '0.9.6.1 : Combobox.'  + #13#10 +
                                              '0.9.6.0 : Auto sizes and scaling.'  + #13#10 +
                                              '0.9.5.0 : Import Field.'  + #13#10 +
                                              '0.9.4.0 : Behaviors and templates.'  + #13#10 +
                                              '0.9.3.1 : Small fixes.'  + #13#10 +
                                              '0.9.3.0 : Struct from template.'  + #13#10 +
                                              '0.9.2.0 : centralizimg on manframes.'  + #13#10 +
                                              '0.9.1.6 : Adapting to ManFrames and auto create sql.'  + #13#10 +
                                              '0.9.1.5 : centralizing on ManFrames.'  + #13#10 +
                                              '0.9.1.4 : UTF 8.'  + #13#10 +
                                              '0.9.1.3 : Testing.'  + #13#10 +
                                              '0.9.1.2 : Forcing Not registered forms when searching form xml file.'  + #13#10 +
                                              '0.9.1.1 : Integrating TXMLFillCombo button.'  + #13#10 +
                                              '0.9.1.0 : Really integrating group view.'  + #13#10 +
                                              '0.9.0.2 : Childs Source for struct node.'  + #13#10 +
                                              '0.9.0.1 : Creating struct fields and components.'  + #13#10 +
                                              '0.9.0.0 : Reading a LEONARDI file and creating HMI.'  + #13#10 +
                                              '0.0.2.0 : Identification, more functionalities.'  + #13#10 +
                                              '0.0.1.0 : Working on weo.'   ;
                                  UnitType  : 3 ;
                                  Major : 0 ; Minor : 9 ; Release : 7; Build : 1 );
{$ENDIF}

type
  { TF_XMLForm }
  { Form created from XML}

  TF_XMLForm = class(TF_CustomFrameWork)
  private
  { Déclarations privées }
     // XML Creating
    gpan_ControlLast  ,
    gpan_Left  ,
    gpan_Right : TPanel;
    gwin_Resize,
    gwin_Parent : TWinControl;
    gi_group, gi_groupsMiddle : Integer;
    gs_group : String;
    gi_LastFormFieldsHeight, gi_LastFormColumnHeight : Longint;
    gat_Template, gat_SomeTemplate : TActionTemplate ;
    gfin_FormIni : TOnFormInfoIni ;
    FPageControl : TCustomTabControl ;
    FPanelMain   ,
    FActionPanel : TPanel;
    gs_Function  : String;
    gi_Function, gi_SomeFunction  : Integer;
    gfwe_Password, gfwe_Login : TFWEdit;
    gcx_FormCreating : TDoCreateFromXML;
    gbtn_PrintButton : TFWPrintSources;
    function fb_CreateField ( const anod_Fields, anod_Field: TALXMLNode;
                              const afws_Source : TFWSource ;
                              const awin_parent : TWinControl;
                              var acon_Control : TControl;
                              var acon_controlResult : TPanel;
                              var as_name, as_group, as_tab : String;
                              var   anod_FieldImport, anod_OriginalNode, anod_TemplateNode  : TALXMLNode;
                              var adoc_ClassImport: TALXMLDocument;
                              var afd_Field1, afd_Field2: TFWFieldColumn;
                              var ai_FieldCounter: Longint;
                              var acx_FormCreate: TDoCreateFromXML;
                              const ab_SeparateIfTooMuch: Boolean=True): Boolean;
    procedure p_CloseLoginAction(AObject: TObject;
      var ACLoseAction: TCloseaction);
    procedure p_CreateArrayStructComponentsControls(
      const ADBSources: TFWTables;
      const ADBSource : TFWTable;
      const affd_ColumnFieldDef: TFWFieldColumn; const anod_Field: TALXMLNode;
      const acon_control: TControl;
      var acx_FieldColumn: TDoCreateFromXML;
      var ai_Fieldcounter: Longint);
    procedure p_CreateField(const anod_Fields, anod_Field: TALXMLNode;
      const afws_Source: TFWSource;
      var   anod_FieldImport  : TALXMLNode ;
      var   adoc_ClassImport : TALXMLDocument;
      var acx_FormCreate: TDoCreateFromXML;
      var ai_FieldCounter: Longint; const ab_SeparateIfTooMuch: Boolean=True);
    procedure p_LoginCancelClick(AObject: TObject);
    procedure p_LoginOKClick(AObject: TObject);
    procedure p_onIniComponent(const AComponent: TComponent;
      const AInifile: TCustomInifile; var KeepOnComponent: Boolean);
    procedure p_setFunction ( const a_Value : Integer );
    procedure p_setFunctionClep ( const a_Value : String );
    function fb_setStructControl(const afws_Source, afws_source2: TFWTable;
      const anod_Field : TALXMLNode;
      const afd_Field1: TFWFieldColumn; const acon_Control: TControl;
      var lcx_columnField: TDoCreateFromXML; var ai_FieldCounter: Integer): Boolean;
  protected
    gxml_SourceFile : TALXMLDocument ;
    gxml_classTemplate : TALXMLDocument;
    gnod_classTemplate : TALXMLNode;
    procedure FinalizeFunction; virtual;
    procedure ResizeScrollBox(const acon_control : TControl); virtual; overload;
    procedure ResizeScrollBox(const ai_width: Integer); virtual; overload;
    function fwin_CreateMainPanelsDoubleColumn(const awin_Panel: TWinControl ): TWinControl;
    function fb_CreateComponentAndProperties(var acon_Control : TControl;
              const anod_Field: TALXMLNode;
              const affd_ColumnFieldDef : TFWFieldColumn;
              const afws_Source : TFWSource ;
              const   awin_parent : TWinControl;
              var   axfc_ButtonCombo : TXMLFillCombo;
              const as_name : String;
              var   act_ComponentType  : TComponentType;
              const   ai_FieldCounter : Longint ;
              const   acx_FormCreate : TDoCreateFromXML  ):Boolean;
    procedure p_ScruteComposantsFiche (); override;
    procedure p_setChoiceComponent( const argr_Control : TCustomRadioGroup );
    function  fpan_CreateFieldComponentAndProperties( const anod_Fields : TALXMLNode;
                                                            anod_Field : TALXMLNode;
                                                      const afws_Source : TFWSource ;
                                                      var   anod_FieldImport  : TALXMLNode;
                                                      var   adoc_ClassImport : TALXMLDocument;
                                                      var   awin_parent: TWinControl;
                                                            awin_last : TControl;
                                                      var   ai_FieldCounter : Longint ;
                                                      var   acx_FormCreate : TDoCreateFromXML ;
                                                      const ab_SeparateIfTooMuch : Boolean = True ):TPanel; virtual;
    function fwin_tablesGoogleMap                   ( var   awin_parent: TWinControl;
                                                            awin_last : TControl;
                                                      const ai_FieldCounter : Longint ;
                                                      var   acx_FormCreate : TDoCreateFromXML ;
                                                      const afws_Source : TFWSource ;
                                                      const ab_SeparateIfTooMuch : Boolean = True ):TPanel; virtual;
    function  ftree_CreateTree                      ( var   awin_parent: TWinControl;
                                                            awin_last : TControl;
                                                      const ai_FieldCounter : Longint ;
                                                      var   acx_FormCreate : TDoCreateFromXML ;
                                                      const afws_Source : TFWSource ;
                                                      const ab_SeparateIfTooMuch : Boolean = True ):TCustomVirtualStringTree; virtual;
    function fpan_setFieldComponentProperties( var   alab_Label : TFWLabel ;
                                               const acon_control : TControl;
                                               const anod_Field1,anod_Field2: TALXMLNode;
                                               const apan_ControlPanel : TPanel;
                                               const as_name : String;
                                               const awin_Parent : TWinControl;
                                               const acx_FormCreate : TDoCreateFromXML;
                                               const ai_Counter: Integer; const ab_Column: Boolean;
                                               const afcf_ColumnField: TFWFieldColumn): TPanel;
    procedure p_SetFieldButtonsProperties(const anod_Action : TALXMLNode;
      const ai_Counter: Integer); virtual;
    procedure p_SetTemplatesProperties(const ai_counter : Integer;var afc_formcreate:TDoCreateFromXML);
    function fwin_SetActionPanels:TWinControl; virtual;
    procedure p_SetControlHeight(const anod_Action: TALXMLNode;const awin_control : TWinControl); virtual;
    procedure p_setControlName ( const as_FunctionName : String ; const anod_FieldProperty : TALXMLNode ;  const awin_Control : TControl; const ai_Counter : Longint ); virtual;
    function  fb_ChargementNomCol ( const AFWColumn : TFWSource ; const ai_NumSource : Integer ) : Boolean; override;
    procedure p_AfterColumnFrameShow( const aFWColumn : TFWSource ); override;
    procedure DoClose ( var CloseAction : TCloseAction ); override;
    function fb_ChargeDonnees : Boolean; override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    function fwin_GridNavigationComponents(const awin_Parent: TWinControl; const as_Name : String ;
      const ai_Counter: Integer): TWinControl; virtual;
    procedure p_AdaptControls; override;
  public
    function fb_InsereCompteur ( const adat_Dataset : TDataset ;
                                 const aff_Cle : TFWFieldColumns ;
                                 const as_ChampCompteur, as_Table, as_PremierLettrage : String ;
                                 const ach_DebutLettrage, ach_FinLettrage : Char ;
                                 const ali_Debut, ali_LimiteRecherche : Int64 ): Boolean; override;

    procedure DoShow; override;
    { Déclarations publiques }
    procedure p_setLogin ( const axml_Login : TALXMLDocument;
                           const axb_ident : TJvXPButton ;
                           const amen_MenuIdent : TMenuItem ;
                           const aiml_Images : TImageList ;
                           const abmp_DefaultImage : TBitmap ;
                           var ai_CountImages : Longint );
    procedure BeforeCreateFrameWork(Sender: TComponent);  override;
    procedure DestroyComponents ( const acom_Parent : TWinControl ); virtual;
    procedure p_CreateFormComponents ( const as_XMLClass, as_Name : String ;  awin_Parent : TWinControl ) ; virtual;
    constructor Create ( AOwner : TComponent ); override;
    destructor Destroy; override;
    property Fonction : integer read gi_Function write p_setfunction;
    property FonctionClep : String read gs_Function write p_setfunctionClep;
  published
    property ActionPanel : TPanel read FActionPanel write FActionPanel;
    property PanelMain   : TPanel read FPanelMain write FPanelMain;
    property PageControl : TCustomTabControl read FPageControl write FPageControl;
  end;


implementation

uses u_languagevars,
     U_ExtNumEdits,
     u_extradios,
     unite_messages,
     fonctions_autocomponents,
     fonctions_scaledpi,
     fonctions_dialogs,
     fonctions_proprietes,
     virtualtablesdbtree,
     typinfo,
     Math,
     fonctions_Objets_Dynamiques,
     fonctions_languages,
     U_ExtImage,
     u_buttons_defs,
     fonctions_persistent,
     fonctions_forms,
     fonctions_db,
     fonctions_xmlform,
     u_buttons_appli,
     unite_variables;

var  gb_LoginFormLoaded : Boolean = False;


// procedure p_CreateFieldsButtonsComponents
// Creates the Fields and buttons
// event called by ft_createcomponents for actions
// anod_ANode : current node
procedure p_OnButtonsComponents (  const ADBSources : TFWTables;const ADBSource : TFWTable;
                                   const anod_ANode : TALXMLNode ;
                                   var   afc_FormCreating : TDoCreateFromXML;
                                   const awin_last  : TWinControl = nil ;
                                   const ai_counter : Integer = 0 );
var li_i, li_j : Longint;
    lnod_ANode : TALXMLNode ;
    lwin_last : TWinControl;
    li_counter : Integer;
Begin
 li_counter := ai_counter;
 lwin_last  := awin_last;
  if  ( anod_ANode.NodeName = CST_LEON_ACTIONS )
  or  ( anod_ANode.NodeName = CST_LEON_COMPOUND_ACTION ) then
    with ADBSources.Owner as TF_XMLForm do
      Begin
        for li_i := 0 to anod_ANode.ChildNodes.Count -1 do
          Begin
           lnod_ANode := anod_ANode.ChildNodes [ li_i ];
           if  (( lnod_ANode.NodeName = CST_LEON_ACTION ) or ( lnod_ANode.NodeName = CST_LEON_ACTION_REF )) then
             // action = button
            Begin
             p_SetFieldButtonsProperties ( lnod_ANode, ADBSource.Index );
             if lnod_ANode.HasChildNodes Then
              for li_j := 0 to lnod_ANode.ChildNodes.Count-1 do
                p_OnButtonsComponents(ADBSources,ADBSource,lnod_ANode.ChildNodes[li_j],afc_FormCreating,lwin_last,li_counter);
            end;
          end;
      End;
End;


// functions and procédures not methods
// event called by ft_createcomponents for class
procedure p_OnColumnNameNode ( const ADBSources : TFWTables; const ADBSource : TFWTable; const anod_ANode : TALXMLNode ;
                               var   afc_FormCreating : TDoCreateFromXML ;
                               var   ai_Fieldcounter : Longint);
Begin
  with ADBSources, ADBSources.Owner as TF_XMLForm do
   DBSources [ Count - 1 ].Title := fs_GetLabelCaption ( anod_ANode.Attributes [ CST_LEON_VALUE ] );
End;
// child procedure p_CreateParentAndFieldsComponent
// Creates the navigation grid and fields components
// event called by ft_createcomponents for fields data or local
// anod_ANode : current node
procedure p_OnCreateParentAndFieldsComponent ( const ADBSources : TFWTables;const ADBSource : TFWTable;
                                               const anod_Parent, anod_ANode  : TALXMLNode ;
                                               var   anod_ANodeImport  : TALXMLNode ;
                                               var   adoc_ClassImport : TALXMLDocument;
                                               var   afcFormCreate : TDoCreateFromXML ;
                                               var   ai_Fieldcounter : Longint );
Begin
 // in field node
  if    anod_ANode.HasAttribute(CST_LEON_FIELD_TYPE) // compositions are not yet supported
  and ( anod_ANode.Attributes[CST_LEON_FIELD_TYPE] = CST_LEON_FIELD_COMPOSITION ) Then
    Exit;
  with ADBSources.Owner as TF_XMLForm,ga_Functions[Fonction] do
     Begin
      if gat_SomeTemplate = atmultiPageTable Then
       gb_DoubleColumn := False;
      if not (cxFieldFound in afcFormCreate ) Then
        Begin
         //creates the panels
          if not ( cxMainOnly in afcFormCreate) Then
            Begin
              if ( ADBSources.Count = 1 ) Then
                Begin
                  gwin_Parent := fwin_GridNavigationComponents ( gwin_Parent, Name, ADBSource.Index );
                  Hint := fs_GetLabelCaption ( Name );
                  ShowHint := True;
                End
             else
           {    if gat_SomeTemplate = atmultiPageTable Then
                 Begin
                  fwin_SetActionPanels;
                  gwin_Parent := fwin_GridNavigationComponents ( gwin_Parent, Clep , ADBSource.Index);
                 end
               else}
                Begin
                  gwin_Parent := fpan_CreateTabSheet ( FPageControl, ADBSources.Owner as TWinControl, FPanelMain, Clep, Clep, ADBSources.Owner as TComponent );
                  (ADBSources.Owner as TF_CustomFrameWork).PageControlDetails := FPageControl;
                  gwin_Parent := fwin_GridNavigationComponents ( gwin_Parent, Clep , ADBSource.Index);
                End;
              if gb_DoubleColumn Then
                gwin_Parent:=fwin_CreateMainPanelsDoubleColumn(gwin_Parent);
            end
           Else
            p_SetTemplatesProperties( ADBSource.Index, afcFormCreate );
          afcFormCreate := afcFormCreate+[cxFieldFound];
        end;
      if gat_SomeTemplate = atmultiPageTable
      // if multipage only creates fields, not visible components
       Then p_CreateField ( anod_Parent, anod_ANode, ADBSource as TFWSource,
                            anod_ANodeImport, adoc_ClassImport,
                            afcFormCreate, ai_Fieldcounter, True  )
       else if not (gat_SomeTemplate in [atTree,atMap]) Then
         // creates visible data or local components
            gpan_ControlLast := fpan_CreateFieldComponentAndProperties ( anod_Parent, anod_ANode, ADBSource as TFWSource,
                                                                         anod_ANodeImport, adoc_ClassImport,
                                                                         gwin_Parent, gpan_ControlLast, ai_Fieldcounter,
                                                                         afcFormCreate, True  );
      inc ( ai_Fieldcounter );
     end;
end;


{ TF_XMLForm }

////////////////////////////////////////////////////////////////////////////////
//  Recherche du nom de l'executable pour aller
//  chercher la bonne fonction d'initialisation
////////////////////////////////////////////////////////////////////////////////
constructor TF_XMLForm.Create(AOwner: TComponent);
Begin
  gfin_FormIni := nil;
  if not ( csDesigning in ComponentState ) Then
    Try
     // no lfm, only in ManFrames
      GlobalNameSpace.BeginWrite;

      {$IFDEF FPC}
      CreateNew(AOwner, 1 );
      {$ELSE}
      CreateNew(AOwner);
      {$ENDIF}
    Finally
      GlobalNameSpace.EndWrite;
      gstl_SQLWork := nil ;
      p_InitFrameWork ( AOwner );
      // Creating objects
      p_CreateColumns;

      {$IFDEF SFORM}
      InitSuperForm;
      {$ENDIF}
    End
  Else
   Begin
     inherited ;
     Exit ;
   end;
  DBCloseMessage := True;
  gfwe_Password := nil;
  gfwe_Login    := nil;
  gxml_SourceFile := nil ;
  gxml_classTemplate   := nil;
  gwin_Parent          := nil;
  gnod_classTemplate   := nil;
  gat_SomeTemplate     := atStandard;
  gat_Template         := atStandard;
  FPanelMain           := nil;
  FActionPanel         := nil;
  gpan_ControlLast     := nil;
  gpan_Left            := nil;
  gpan_Right           := nil;
  gwin_Resize          := nil;

  FinalizeFunction;
end;

destructor TF_XMLForm.Destroy;
begin
  gfin_FormIni.p_ExecuteEcriture(Self);  //ini writing
  DestroyComponents(nil); // destroying to get blank form
  inherited;
end;


// procedure DestroyComponents
// Destroy all the visible components for the form to be re-used
// Initiate the XML Form
// Parameter : acom_Parent : If not nil destroy only the controls child of acom_Parent
procedure TF_XMLForm.DestroyComponents( const acom_Parent : TWinControl );
var li_i : Integer ;
begin
  FreeAndNil(gxml_SourceFile);
  FreeAndNil(gxml_classTemplate);
  for li_i := ComponentCount -1 downto 0 do
    if ( not assigned ( acom_Parent )
        or (( Components [ li_i ] is TWinControl ) and ( acom_Parent = ( Components [ li_i ] as TWinControl ).Parent ))) Then
      Begin
        Components [ li_i ].Destroy;
      End ;
  gpan_Left := nil;
  gwin_Parent:=nil;
  DBSources.Clear;
  p_InitFrameWork ( Self );
  FinalizeFunction;
end;


// Function fb_ChargementNomCol
// Inherited function, just make it true
function TF_XMLForm.fb_ChargementNomCol(const AFWColumn: TFWSource;
  const ai_NumSource: Integer): Boolean;
begin
  Result := True;
end;


// function fpan_GridNavigationComponents
// Create a complete Grid navigation with Navigators returning the child created ScrollBox for the editing form
// awin_Parent : The grid navigation and editing parent
// const as_Name : name for caption
// const ai_Counter : Column counter
function TF_XMLForm.fwin_GridNavigationComponents ( const awin_Parent : TWinControl ; const as_Name : String ; const ai_Counter : Integer ): TWinControl;
var lpan_ParentPanel : TPanel ;
    lpan_Panel : TPanel ;
    ldbn_Navigator : TExtDBNavigator ;
    ldbg_Grid      : TCustomDBGrid;
    lfwc_Column    : TFWSource ;
    lcon_Control   : TControl ;
begin
  lfwc_Column := DBSources [ ai_Counter ] as TFWSource;
  // Main panel of table
  lpan_ParentPanel := fpan_CreatePanel ( awin_Parent, CST_COMPONENTS_PANEL_MAIN + as_Name + IntToStr(ai_counter), Self, alClient );
  lpan_ParentPanel.Hint := fs_GetLabelCaption ( as_Name );
  lpan_ParentPanel.ShowHint := True;

  // grid only for multipage
  if gat_SomeTemplate <> atmultiPageTable Then
   Begin
    lpan_Panel := fpan_CreatePanel ( lpan_ParentPanel, CST_COMPONENTS_DBGRID + as_Name + IntToStr(ai_counter), Self, alLeft );
    lpan_Panel.Width := CST_GRID_NAVIGATION_WIDTH;
    lpan_Panel.Constraints.MinWidth := CST_GRID_NAVIGATION_MIN_WIDTH;
   end
  Else lpan_Panel := lpan_ParentPanel;
  ldbn_Navigator := fdbn_CreateNavigation ( lpan_Panel, CST_COMPONENTS_DBGRID + as_Name + IntToStr(ai_counter), Self, False, alTop );
  lfwc_Column.Navigator := ldbn_Navigator;
  ldbg_Grid      := fdbg_CreateGrid ( lpan_Panel, CST_COMPONENTS_DBGRID + as_Name + IntToStr(ai_counter), Self, False, alClient );
  lfwc_Column.Grid := ldbg_Grid;

  // grid only for multipage
  if gat_SomeTemplate <> atmultiPageTable Then
    Begin
      lcon_Control := fspl_CreateSplitter ( lpan_ParentPanel, CST_COMPONENTS_DBGRID + as_Name + IntToStr(ai_counter), Self, alLeft, lpan_Panel );
      lpan_ParentPanel := fpan_CreatePanel ( lpan_ParentPanel, as_Name + IntToStr(ai_counter), Self, alClient );
      lpan_ParentPanel.Hint := fs_GetLabelCaption ( as_Name );
      lpan_ParentPanel.ShowHint := True;
      lpan_Panel := fpan_CreatePanel ( lpan_ParentPanel, CST_COMPONENTS_EDIT + as_Name + IntToStr(ai_counter), Self, alTop );
      ldbn_Navigator := fdbn_CreateNavigation ( lpan_Panel, CST_COMPONENTS_EDIT + as_Name + IntToStr(ai_counter), Self, True, alTop );
      lfwc_Column.NavEdit := ldbn_Navigator;
      Result := fscb_CreateScrollBox ( lpan_ParentPanel, CST_COMPONENTS_CONTROLS + as_Name + IntToStr(ai_counter), Self, alClient );
      lfwc_Column.Panels.Add.Panel := Result ;
    end
   Else
    Begin
     lfwc_Column.NavEdit := ldbn_Navigator;
     Result := lpan_ParentPanel;
    end;
End;

// p_AdaptControls
// resizing controls after creating
procedure TF_XMLForm.p_AdaptControls;
begin
  // in the create because we can do
end;

// resize Client Width to make scrollings
procedure TF_XMLForm.ResizeScrollBox(const ai_width : Integer);
begin
 with gwin_Resize do
 if ai_width > ClientWidth Then
   ClientWidth:= ai_width;
end;

// function TF_XMLForm.fwin_CreateMainPanelsDoubleColumn
// creates double column
function TF_XMLForm.fwin_CreateMainPanelsDoubleColumn( const awin_Panel :TWinControl ):TWinControl;
var lspl_Splitter : TSplitter;
Begin
  gwin_Resize := awin_Panel;
  if gb_DoubleColumn Then
   begin // creates double column
    if not assigned ( gpan_Left ) Then
      Begin
       gpan_Left :=fpan_CreatePanel(awin_Panel,'PanelLeft',Self,alLeft);
       gpan_Left.Width:=CST_XML_SEGUND_COLUMN_MIN_POSWIDTH;
       ScaleDPIControl(Self,gpan_Left);
       lspl_Splitter := fspl_CreateSplitter (awin_Panel,'SplitterMiddlePanels',Self,alLeft,gpan_Left);
       gpan_Right:=fpan_CreatePanel(awin_Panel,'PanelRight',Self,alClient);
       gpan_Left.Width:=CST_XML_SEGUND_COLUMN_MIN_POSWIDTH;
       ResizeScrollBox ( gpan_Right );
       ScaleDPIControl(Self,gpan_Right);
       Result:=gpan_Left;
      end
     else
      if awin_Panel = gpan_Right
       Then Result:=gpan_Left
       Else Result:=gpan_Right;
  end
   else Result:=awin_Panel;

end;

// overrided procedure p_AfterColumnFrameShow
// aFWColumn : abstract Column showing
procedure TF_XMLForm.p_AfterColumnFrameShow( const aFWColumn : TFWSource );
begin
end;

// overrided procedure DoClose
// Free the XML Form
// Setting CloseAction to cafree
procedure TF_XMLForm.DoClose(var CloseAction: TCloseAction);
begin
  inherited DoClose(CloseAction);
  CloseAction := caHide;
end;

// function TF_XMLForm.fb_ChargeDonnees
// option data setting
function TF_XMLForm.fb_ChargeDonnees: Boolean;
begin
  Result:= True;
end;

// function TF_XMLForm.fb_InsereCompteur
// counter setting by software
// very slow
function TF_XMLForm.fb_InsereCompteur(const adat_Dataset: TDataset;
  const aff_Cle: TFWFieldColumns; const as_ChampCompteur, as_Table,
  as_PremierLettrage: String; const ach_DebutLettrage, ach_FinLettrage: Char;
  const ali_Debut, ali_LimiteRecherche: Int64): Boolean;
begin
  Result:=False;
end;


// procedure p_setLogin
// Special Login model
// axml_Login : XML Document of login form
procedure TF_XMLForm.p_setLogin(const axml_Login: TALXMLDocument;
  const axb_ident: TJvXPButton; const amen_MenuIdent: TMenuItem;
  const aiml_Images: TImageList; const abmp_DefaultImage: TBitmap;
  var ai_CountImages: Longint);
var
    li_i, li_j, li_Counter : Longint;
    lnod_Node, lnod_NodeChild : TALXMLNode ;
    gxmd_xmlSource : TALXMLDocument;
    ls_class   : String;
    lwin_Control  : TWinControl;
    lpan_ControlPanel : TPanel;
    lfwl_Label    : TFWLabel;
    lfwc_Column   : TFWSource ;
    lxml_Class : TALXMLDocument;
    lpan_Label : TPanel;
    lfc_formcreating : TDoCreateFromXML;
begin
  DisableAlign ;
  ScaleFont(Font);
  Screen.Cursor := Self.Cursor;
  for li_i := 0 to axml_Login.ChildNodes.Count - 1 do
    Begin // reading login nodes
      lnod_Node := axml_Login.ChildNodes [ li_i ];
      if lnod_Node.NodeName = CST_LEON_ACTION Then
        Begin
          lfwc_Column := nil;
          Width  := 350;
          Height := 250 ;
          // Creating DBSources
          if lnod_Node.HasChildNodes Then
          for li_j := 0 to lnod_Node.ChildNodes.Count - 1 do
            Begin
              lnod_NodeChild := lnod_Node.ChildNodes [ li_j ];
              if  ( lnod_NodeChild.NodeName = CST_LEON_ACTION_PREFIX )
              and not gb_LoginFormLoaded then
               Begin
                 p_setPrefixToMenuAndXPButton ( lnod_NodeChild.Attributes [ CST_LEON_VALUE ], axb_ident, amen_MenuIdent, aiml_Images );
                 gb_LoginFormLoaded := True;
               end;
              if lnod_NodeChild.NodeName = CST_LEON_NAME Then
                Caption := fs_GetLabelCaption(lnod_NodeChild.Attributes [ CST_LEON_VALUE ]);
              if  ( lnod_NodeChild.NodeName = CST_LEON_PARAMETER )
              and lnod_NodeChild.HasAttribute ( CST_LEON_PARAMETER_NAME )
              and ( lnod_NodeChild.Attributes [ CST_LEON_PARAMETER_NAME ] = CST_LEON_USER_CLASS )
               Then
                 Begin
                   if lnod_NodeChild.HasAttribute ( CST_LEON_IDREF )
                    Then ls_class := lnod_NodeChild.Attributes [ CST_LEON_IDREF ]
                    else Application.Terminate;

                   gxmd_xmlSource := nil;
                   try
                     lfwc_Column := ft_CreateComponents ( DBSources, ls_class, ls_class, lxml_Class, Self, nil, nil, nil, [cxMainOnly,cxCreateDS] ) as TFWSource;
                   finally
                     lxml_Class.Free;
                   end;
                   {$IFDEF DBNET}
                     If  assigned ( lfwc_Column )
                     and assigned ( lfwc_Column.Connection )
                     and ( lfwc_Column.Connection.DatasetType = dtDBNet ) Then
                      Begin
//                       p_SetComponentBoolProperty(lfwc_Column.Connection.QueryCopy, 'GetFields', True );
                       p_FindAndSetSourceKey(lnod_NodeChild.Attributes [ CST_LEON_IDREF ],'',DBSources, lfwc_Column, Self, FieldDelimiter);
                      end;
                   {$ENDIF}
                 end;
              if lnod_NodeChild.NodeName = CST_LEON_ACTIONS Then
               Begin
                FActionPanel:=fpan_CreatePanel(Self,'ActionsPanel',Self,alClient);
                lfc_formcreating := [];
               end;
            end;
          li_Counter := 0 ;
          // Setting login parameters
          for li_j := 0 to lnod_Node.ChildNodes.Count - 1 do
            Begin
              lnod_NodeChild := lnod_Node.ChildNodes [ li_j ];
              with lnod_NodeChild do
              if  ( NodeName = CST_LEON_PARAMETER )
              and HasAttribute ( CST_LEON_PARAMETER_NAME )
              and (  ( Attributes [ CST_LEON_PARAMETER_NAME ] = CST_LEON_LOGIN_INFO    )
                  or ( Attributes [ CST_LEON_PARAMETER_NAME ] = CST_LEON_PASSWORD_INFO ))
               Then
                Begin
                   Begin
                     lwin_Control := fwin_CreateAEditComponent ( Self, False, ctLocal );
                     with lwin_Control do
                      Begin // creating local control
                       Parent := fpan_CreatePanel(Self,'Panel'+Attributes [ CST_LEON_PARAMETER_NAME ],Self,alTop);
                       Left := CST_XML_FIELDS_CAPTION_SPACE;
                       Name := CST_COMPONENTS_EDIT_BEGIN+Attributes [ CST_LEON_PARAMETER_NAME ]+IntToStr(li_j);
                       Text := '';
                       Align:=alClient;
                       Width := 120;
                      end;
                     ScaleDPIControl(Self,lwin_Control);
                     lpan_Label   := fpan_CreateALabelComponent ( lfwl_Label, Self, lwin_Control.Parent, lwin_Control, lfwc_Column.FieldsDefs.Add, Attributes [ CST_LEON_PARAMETER_NAME ], Attributes [ CST_LEON_PARAMETER_NAME ], li_Counter, False );
                     if ( Attributes [ CST_LEON_PARAMETER_NAME ] = CST_LEON_LOGIN_INFO ) Then
                       Begin // creating label
                         li_counter := 0;
                         lwin_Control.Top := 50 ;
                         lfwl_Label  .Top := 50 ;
                         lfwl_Label  .Caption := GS_LOGIN;
                         gfwe_Login := lwin_Control as TFWEdit;
                       end
                      Else
                       Begin
                         li_counter := 1;
                         lwin_Control.Top := 100 ;
                         lfwl_Label  .Top := 100 ;
                         lfwl_Label  .Caption := GS_PASSWORD;
                         gfwe_Password := lwin_Control as TFWEdit;
                         gfwe_Password.PasswordChar:='*';
                       End;
                     ScaleDPIControl(Self,lfwl_Label);
                     with lfwc_Column.FieldsDefs [ lfwc_Column.FieldsDefs.Count - 1 ] do
                       Begin
                         FieldName:= Attributes [ CST_LEON_IDREF ];
                         NumTag:= li_counter + 1 ;
                         if ( Attributes [ CST_LEON_PARAMETER_NAME ] = CST_LEON_LOGIN_INFO    )
                          Then
                           ColUnique:=True;
                       end;
                   end;
                end;
            end;
          // Setting buttons
          lwin_Control := TFWOK.Create(Self);
          ScaleDPIControl(Self,lwin_Control);
          lpan_ControlPanel := fpan_CreatePanel(Self,'PanelButtons',Self,alBottom);
          with lwin_Control as TFWOK do
           Begin // ok button
            Parent := lpan_ControlPanel;
            Name   := CST_COMPONENTS_BUTTON_BEGIN+ClassName+IntToStr(li_i);
            Width  := 90;
            Height := 25;
            Left:= Self.Width div 2 - ( Width * 2 ) div 2;
            Top := 150 ;
            OnClick := p_LoginOKClick;
            Align:=alLeft;
           end;
          lwin_Control := TFWCancel.Create(Self);
          ScaleDPIControl(Self,lwin_Control);
          with lwin_Control as TFWCancel do
           Begin // cancel button
            Parent := lpan_ControlPanel;
            Name   := CST_COMPONENTS_BUTTON_BEGIN+ClassName+IntToStr(li_i);
            Width  := 90;
            Height := 25;
            Left:= Self.Width div 2 + Width div 2;
            Top := 150 ;
            OnClick := p_LoginCancelClick;
            Align:=alRight;
           end;
        end;
      end;
  if not gb_LoginFormLoaded Then
    Begin
      gb_LoginFormLoaded := True;
      p_setImageToMenuAndXPButton(abmp_DefaultImage,axb_ident,amen_MenuIdent,aiml_Images);
    end;
  ai_CountImages:=aiml_Images.Count;
  OnClose:=p_CloseLoginAction;
  Name := CST_COMPONENTS_FORM_BEGIN + 'AutoLoginForm' ;
  // Initiate data and showing
  EnableAlign ;
  FormCreate;
  Position := poMainFormCenter;
//  FormStyle:=fsNoStayOnTop;
//  Application.MainForm.WindowState:=wsMinimized;
  ShowModal;
//  Application.MainForm.WindowState:=wsMaximized;
end;
// procedure p_LoginOKClick
// Login OK Button event
// AObject : Needed for event
procedure TF_XMLForm.p_LoginOKClick( AObject : TObject );
var lb_ok : Boolean;
Begin
  if assigned ( gNod_DashBoard ) Then
  with DBSources [ 0 ] do
   if Datasource.DataSet.Active Then
    Begin
      // no user so can enter
      if Datasource.DataSet.IsEmpty Then
        Begin
          p_CreeAppliFromNode ( '' );
          Close;
          Exit;
        end;
      // Verifying form
      if  not assigned ( gfwe_Password )
      and not Assigned( gfwe_Login ) Then
        Exit;
      lb_ok := False;
      // verifying password
      if FieldsDefs [ 0 ].NumTag = 1 Then
        Begin
          Datasource.DataSet.Locate(FieldsDefs [ 0 ].FieldName,gfwe_Login.Text,[loCaseInsensitive]);
          if Datasource.DataSet.FieldByName(FieldsDefs [ 1 ].FieldName).AsString = gfwe_Password.Text Then
            lb_ok := True;
        end
       Else
        Begin
         Datasource.DataSet.Locate(FieldsDefs [ 1 ].FieldName,gfwe_Login.Text,[loCaseInsensitive]);
         if Datasource.DataSet.FieldByName(FieldsDefs [ 0 ].FieldName).AsString = gfwe_Password.Text Then
           lb_ok := True;
        end;
      if lb_ok Then
        Begin
          // creating software
          gs_user := gfwe_Login.Text;
          p_CreeAppliFromNode ( '' );
          Close;
          Exit;
        end
       Else
        MyShowmessage(GS_LOGIN_FAILED);
    end;
end;

// procedure TF_XMLForm.KeyUp
// Auto OK Login key event
// AObject : Needed for event
procedure TF_XMLForm.KeyUp(var Key: Word; Shift: TShiftState);
begin
  inherited KeyUp(Key, Shift);
  if ( Key = VK_RETURN )
  and assigned ( gfwe_Password ) Then
   p_LoginOKClick (Self );
end;

// procedure TF_XMLForm.DoShow
// finalizing form because loaded not called (no lfm)
procedure TF_XMLForm.DoShow;
begin
 // ini reading
  gfin_FormIni.p_ExecuteLecture(Self);
  inherited;
end;

procedure TF_XMLForm.p_onIniComponent ( const AComponent : TComponent  ; const AInifile : TCustomInifile ; var KeepOnComponent : Boolean );
{   procedure p_FindImportRelation;
   var li_k : Integer;
       ls_Relation, ls_FilteredField : String;
   Begin
      ls_Relation := fs_getComponentProperty(lcom_Component,CST_IMPORT_RELATION);
      ls_FilteredField:= fs_getComponentProperty(lcom_Component,CST_FILTERED_FIELD);
      for li_k := 0 to ComponentCount - 1 do
       Begin
        lcom_Control := Components [ li_k ];
        if ( pos ( ls_Relation, lcom_Control.Name ) > 1 )
        and (   ( lcom_Control is TDBGroupView )
              or IsPublishedProp ( lcom_Control, CST_DBPROPERTY_SEARCHSOURCE)
              or IsPublishedProp ( lcom_Control, CST_DBPROPERTY_LOOKUPSOURCE))
        Then
         Begin
          p_SetComponentObjectProperty(lcom_Component,CST_FILTERED_FIELD,lcom_Control);
          Exit;
         end;
       end;
   end; }
  procedure p_SetControlsToRules;
  var li_i,li_j : Integer;
     lfwr_Rules : TFWRules;
     lcom_Control : TComponent;
  Begin
  lfwr_Rules := fobj_getComponentObjectProperty(AComponent,CST_PROPERTY_RULES) as TFWRules;
  for li_i := 0 to lfwr_Rules.Count-1 do
   with lfwr_Rules [ li_i ] do
    if  ( FieldName > '' )
    and not (Rule in [seOption,seNeeded]) Then
     Begin
      for li_j := 0 to ComponentCount-1 do
       Begin
        lcom_Control := Components [ li_j ];
        //MyShowMessage(FieldName+#13#10+lcom_Control.Name+#13#10+lcom_Control.ClassName);
        if  ( lcom_Control is TControl )
        and ( pos ( FieldName, lcom_Control.Name) > 1 )
        and IsNumber( lcom_Control.Name [ pos ( FieldName, lcom_Control.Name) + Length(FieldName) ]) Then
         Begin
          Edit:=lcom_Control as TControl;
          FieldName:='';
          Exit;
         End;
       End;
     end;
  end;
Begin
  if ( AComponent is TExtDBNumEdit )
   then with  AComponent as TExtDBNumEdit do
    Begin
      DataSource.DataSet.Open;
      if ( DataSource.DataSet.FieldByname ( DataField ) is TIntegerField )   then
        Begin
         DecimalPlaces:=0;
        end;

    end;
 //  if AComponent is IImportComponent Then
   //  p_FindImportRelation;

   if AComponent is IRuleComponent Then
     p_SetControlsToRules;

  if AComponent is TFWButton Then
   Begin
    (AComponent as TFWButton).Loaded;
    Exit;
   end;
  if AComponent is TExtImage Then
   Begin
    (AComponent as TExtImage).Loaded;
    Exit;
   end;
  if AComponent is TDBGroupView Then
   Begin
     (AComponent as TDBGroupView).Loaded;
   end;
end;

// procedure p_CloseLoginAction
// Login close event
procedure TF_XMLForm.p_CloseLoginAction( AObject : TObject; var ACLoseAction : TCloseaction );
Begin
  ACloseAction := caHide;
  gf_users := nil;
end;

// procedure p_LoginCancelClick
// Cancel Click event
procedure TF_XMLForm.p_LoginCancelClick( AObject : TObject );
Begin
  Close;
end;

// procedure p_setControlName
// Setting control name from node
procedure TF_XMLForm.p_setControlName (  const as_FunctionName : String ; const anod_FieldProperty : TALXMLNode ;  const awin_Control : TControl; const ai_Counter : Longint );
Begin
  awin_Control.Name := fs_EraseSpecialChars( awin_Control.ClassName + as_FunctionName + trim ( anod_FieldProperty.Attributes [ CST_LEON_VALUE ] ) + IntToStr ( ai_Counter ));

End;



// procedure p_setFunction
// Creating the components of the form from TLeonFunction into array
// a_Value : Menu function
procedure TF_XMLForm.p_setFunction(const a_Value: Integer);
var li_Action : Longint ;
    lpan_Panel : TPanel;
    AFormClass : TPersistentClass;
    AFormXML : TF_XMLForm;
    procedure p_SetFunctions ( const ali_Function : Integer );
      procedure p_SetSomeFunctions;
      var li_i, li_j : Integer ;
      Begin
        with ga_Functions  [ ali_Function ] do
        for li_i := 0 to ( high ( Functions )) do
          Begin
            li_Action := fi_FindAction ( Functions [ li_i ] );
            with ga_Functions [ li_Action ] do
             Begin
               if High(Functions)> -1 Then
                Begin // recursive multiple function
                 for li_j := 0 to High(Functions) do
                   p_SetFunctions(fi_FindAction ( Functions [ li_j ] ));
                 Exit;
                end;
               // simple function
               gi_group := -1;
               gs_group := '';
               AFormXML := nil;
               AFormClass:=nil;
               if Behavior > '' Then
                 Begin
                  AFormClass := fper_FindClass('T'+Behavior);
                  if assigned(AFormClass)
                  Then
                    Begin
                     AFormXML := TF_XMLForm (ffor_CreateForm (TFormClass (AFormClass)));
                     with AFormXML do
                      Begin
                       gi_SomeFunction:= li_Action ;
                       gat_SomeTemplate:= Template ;
                       p_CreateFormComponents(AFile, Name, PanelMain);
                      end;
                    end
                  Else MyMessageDlg('Behavior not found. Participate to XML Frames project !');
                 end;
              if AFormXML = nil Then
               Begin
                gi_SomeFunction:=li_Action ;
                gat_SomeTemplate:=Template;
                p_CreateFormComponents ( AFile, Name, PanelMain );
               end;
             end;
          End;

      end;

    Begin
     // Simple function
    with ga_Functions  [ ali_Function ] do
     if (high ( Functions ) < 0 ) then
      Begin
        gi_group := -1;
        gs_group := '';
        gi_SomeFunction:= ali_Function ;
        gat_SomeTemplate := Template ;
        //creates the form
        if assigned ( PanelMain )
         Then p_CreateFormComponents ( AFile,Name, PanelMain )
         Else
          Begin
           PanelMain := fpan_CreateActionPanel ( Self, Self, FActionPanel, Scale );
           p_CreateFormComponents ( AFile,Name,PanelMain);
          end;
      End
     else
      Begin
        // Compound function
//          PanelMain := fpan_CreatePanel ( Self, 'MainPanel'+Self.Name, Self, alClient );
        if not assigned ( PanelMain )
         Then PanelMain := fpan_CreateActionPanel ( Self, Self, FActionPanel, Scale );
        // multiple
        p_SetSomeFunctions;
      end;
    end;

begin
 if gs_Function > ''
  Then
   DestroyComponents ( nil );
 ScaleFont(Font);
 gi_Function:=a_Value;
 with ga_Functions [ a_Value ] do
  Begin
   gs_Function:=Clep;
   gat_Template:=Template;
   Name := Clep;
   DisableAlign ;
   try
     Caption := fs_GetLabelCaption ( Name );
     p_SetFunctions ( gi_Function );
     FormCreate;
    // if DBSOurces.Count > 0 Then MyShowMessage((DBSources [ 0] as TFWSource).Datasource.DataSet.Name);
   finally
     EnableAlign ;
   end;
  end;
end;

// procedure TF_XMLForm.p_setFunctionClep
// creates form from function clep
procedure TF_XMLForm.p_setFunctionClep(const a_Value: String);
begin
  gs_Function:=a_Value;
  p_setFunction(fi_FindAction(gs_Function));
end;

procedure TF_XMLForm.FinalizeFunction;
begin

end;

// resizing scrollings (TSuperForm)
procedure TF_XMLForm.ResizeScrollBox(const acon_control: TControl);
begin
  with acon_control do
   ResizeScrollBox(Top+Height);
end;

// procedure p_setChoiceComponent
// After having read child node from choice node setting the height of choice node
// argr_Control : Choice component
procedure TF_XMLForm.p_setChoiceComponent( const argr_Control : TCustomRadioGroup );
var li_i, li_length : Integer;
Begin
  with argr_Control do
    begin
      Height:= Items.Count  * gi_FontHeight + Byte(BorderStyle)  * 2 ;
      li_length := 0;
      for li_i := 0 to Items.Count -1 do
        li_length:=Max(Canvas.GetTextWidth(Items [ li_i ]), li_length );
      if li_length > 0 Then
        Columns := (CST_XML_SEGUND_COLUMN_MIN_POSWIDTH+CST_XML_FIELDS_LABEL_INTERLEAVING*2) div li_length ;
    end;
end;


// Function fpan_setFieldComponentProperties
// creating the label component and setting the field component from child nodes
// anod_Field : component node
// awin_Control : created field component
// awin_Parent : Parent component
// afd_FieldDef : Field definitions
// ai_Counter : Field Counter
// afws_Source : XML Form Column
// ab_Column : Segund editing column
// afcf_ColumnField : Field Form column definitions

function TF_XMLForm.fpan_setFieldComponentProperties(
                                               var   alab_Label : TFWLabel ;
                                               const acon_control : TControl;
                                               const anod_Field1,anod_Field2: TALXMLNode;
                                               const apan_ControlPanel : TPanel;
                                               const as_name : String;
                                               const awin_Parent : TWinControl;
                                               const acx_FormCreate : TDoCreateFromXML;
                                               const ai_Counter: Integer; const ab_Column: Boolean;
                                               const afcf_ColumnField: TFWFieldColumn): TPanel;

    procedure p_setControlFromNode ( const anod_Field: TALXMLNode);
    var li_i : LongInt ;
        ldo_Temp : Double ;
        lnod_FieldProperties : TALXMLNode ;
    Begin
     if anod_Field.HasChildNodes then
      with DefaultFormatSettings do
       for li_i := 0 to anod_Field.ChildNodes.Count -1 do
         Begin
          // setting control form nodes
           ldo_Temp := 0 ;
           lnod_FieldProperties := anod_Field.ChildNodes [ li_i ];
           if acon_Control is TCustomRadioGroup then
             Begin
               if fb_setChoiceProperties ( lnod_FieldProperties, acon_Control as TCustomRadioGroup ) Then
                 Continue;
             End;

           if acon_Control is TCustomComboBox then
             Begin
               if fb_setComboProperties ( lnod_FieldProperties, acon_Control as TCustomComboBox ) Then
                 Continue;
             End;

           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_NROWS then
             Begin
               p_setComponentProperty ( acon_Control, 'Rows', lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
               Continue;
             End;
           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_TIP then
             Begin
               acon_Control.Hint := fs_GetLabelCaption ( lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
               acon_Control.ShowHint := True;
               Continue;
             End;
           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_NCOLS then
             Begin
               p_setComponentProperty ( acon_Control, 'Cols', lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
               Continue;
             End;
           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_MAX then
             Begin
               if ( acon_Control is TExtNumEdit )
               or ( acon_Control is TCustomFloatSpinEdit ) then
                 try // numedit is a customedit
                   DecimalSeparator := '.' ;
                   ldo_Temp := Abs ( StrToFloat ( lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]));

                   if acon_Control.Width < ldo_Temp * CST_XML_FIELDS_CHARLENGTH then
                     acon_Control.Width := length ( lnod_FieldProperties.Attributes [ CST_LEON_VALUE ] ) * CST_XML_FIELDS_CHARLENGTH;
                   p_setComponentProperty ( acon_Control, 'Max', lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
                   p_setComponentBoolProperty ( acon_Control, 'HasMax', True);
                 Except
                 end
               else if ( acon_Control is TCustomEdit ) then
                 try
                   ldo_Temp := lnod_FieldProperties.Attributes [ CST_LEON_VALUE ];
                   p_setComponentProperty ( acon_Control, 'MaxLength', ldo_Temp);
                   acon_Control.Width :=  CST_XML_FIELDS_CHARLENGTH * StrToInt ( lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
                 Except
                 end;
               try
                 afcf_ColumnField.FieldSize := Trunc ( ldo_Temp );
               Except
               end;
               DecimalSeparator := gchar_DecimalSeparator ;
               Continue;
             End;
           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_MIN then
             Begin
               if ( acon_Control is TExtNumEdit )
               or ( acon_Control is TCustomFloatSpinEdit ) then
                 try  // numedit is a customedit
                   DecimalSeparator := '.' ;
                   ldo_Temp := StrToFloat ( lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
                   if acon_Control.Width < ldo_Temp * CST_XML_FIELDS_CHARLENGTH then
                     acon_Control.Width := Min ( 50, Round ( ldo_Temp * CST_XML_FIELDS_CHARLENGTH ));
                   p_setComponentProperty ( acon_Control, 'Min', ldo_Temp);
                   p_setComponentBoolProperty ( acon_Control, 'HasMin', True);
                 Except
                 end
               else if ( acon_Control is TCustomEdit ) then
                 try
                   ldo_Temp := lnod_FieldProperties.Attributes [ CST_LEON_VALUE ];
                   p_setComponentProperty ( acon_Control, 'MinLength', ldo_Temp);
                 Except
                 end;
               DecimalSeparator := gchar_DecimalSeparator ;
               Continue;
             End;
           if lnod_FieldProperties.NodeName = CST_LEON_FIELD_PITCH then
             Begin
               if ( acon_Control is TCustomFloatSpinEdit ) then
                 try  // numedit is a customedit
                   DecimalSeparator := '.' ;
                   ldo_Temp := StrToFloat ( lnod_FieldProperties.Attributes [ CST_LEON_VALUE ]);
                   p_setComponentProperty ( acon_Control, 'Increment', ldo_Temp);
                 Except
                 end;
               DecimalSeparator := gchar_DecimalSeparator ;
               Continue;
             End;
         End;

    end;

Begin
  Result := nil;
  if ( acon_Control is TCustomGroupBox )
    Then p_setComponentProperty ( acon_Control, CST_PROPERTY_CAPTION, afcf_ColumnField.Caption)
    Else
     Begin
      if cxIsRelation in acx_FormCreate
       Then Result := fpan_CreateALabelComponent ( alab_Label, Self, apan_ControlPanel, acon_Control, afcf_ColumnField, as_name, afcf_ColumnField.Relation.Caption, ai_Counter, ab_Column )
       Else Result := fpan_CreateALabelComponent ( alab_Label, Self, apan_ControlPanel, acon_Control, afcf_ColumnField, as_name, afcf_ColumnField.Caption, ai_Counter, ab_Column );
      // scaling controls in create
      ScaleDPIControl(Self,alab_Label);
      ScaleDPIControl(Self,Result);
     end;
  if Assigned(anod_Field2) Then
   p_setControlFromNode ( anod_Field2 );
  p_setControlFromNode ( anod_Field1 );
  // after setting the choice component setting the height
  if acon_Control is TCustomRadioGroup then
    Begin
      p_setChoiceComponent ( acon_Control as TCustomRadioGroup );
    End;

End;

// function TF_XMLForm.fwin_SetActionPanels
// adding Double columns with Splitter
function TF_XMLForm.fwin_SetActionPanels:TWinControl;
procedure p_addSplitter;
 var lsplitter : TSplitter;
 Begin
   if gwin_Parent.ControlCount < 1
    Then Exit;
   lsplitter := TSplitter.Create(Self);
   lsplitter.Parent:=gwin_Parent;
   with gwin_Parent.Controls[gwin_Parent.ControlCount - 2] do
     lsplitter.Top:=Top+Height;
 end;

Begin
  if not assigned ( gpan_Left ) Then
     gwin_Parent := fwin_CreateMainPanelsDoubleColumn ( gwin_Parent )
   else
    Begin
      if ( gpan_Left.ControlCount <= gpan_Right.ControlCount )
       Then gwin_Parent := gpan_Left
       else gwin_Parent := gpan_Right;
      p_addSplitter;
      gb_DoubleColumn:=True;
      fwin_CreateMainPanelsDoubleColumn(gwin_Parent);
    end;
  Result:=gwin_Parent;

end;

// procedure TF_XMLForm.p_SetControlHeight
// setting control height
procedure TF_XMLForm.p_SetControlHeight(const anod_Action: TALXMLNode;const awin_control : TWinControl);
var li_size : Integer;
    ls_size : String;
Begin
  if anod_Action.HasAttribute(CST_LEON_SIZES) Then
   Begin
     ls_size:= anod_Action.Attributes[CST_LEON_SIZES];
     ls_size:=copy ( ls_size, pos(' ',ls_size)+1,Length(ls_size));
     li_size:=pos ( CST_LEON_PIXELS, ls_size );
     if li_size = 0 Then li_size:=pos ( CST_LEON_POINTS, ls_size );
     try
       if li_size > 0 Then
        Begin
         ls_size:=copy(ls_size,1,li_size-1);
         if IsNumber(ls_size) Then
          awin_control.Height:=StrToInt(ls_size);
        End
       Else
        if IsNumber(ls_size) Then
         awin_control.Height:=(StrToInt(ls_size)*gwin_Parent.Height div 100);
     except
       on e: Exception do
        MyMessageDlg(gs_Error_only,fs_RemplaceMsg(GS_NOMBRE_ENTIER_POSITIF,[ls_size])+':'+#10+E.Message);
     end;
   end;
end;

// procedure p_SetFieldButtonsProperties
// Setting the editing buttons
// anod_Action : Action node for buttons
// ai_Counter : column counter
// awin_Parent : Parent component
procedure TF_XMLForm.p_SetFieldButtonsProperties(const anod_Action: TALXMLNode;
  const ai_Counter: Integer);
var ls_Action : String;
begin
  with DBSources [ ai_Counter ] do
    if  ( anod_Action.NodeName = CST_LEON_ACTION_REF )
    and assigned ( NavEdit ) then
      Begin
        ls_Action :=  anod_Action.Attributes [ CST_LEON_ACTION_IDREF ];
        if ls_Action = CST_LEON_ACTION_REF_SET then
          Begin
            NavEdit.VisibleButtons := NavEdit.VisibleButtons + [nbEPost,nbECancel];
            if ( NavEdit = Navigator )
            and assigned ( Grid ) Then
              p_SetComponentBoolProperty( Grid, CST_PROPERTY_READONLY, False );
            Exit;
          End;

        if ls_Action = CST_LEON_ACTION_REF_DELETE then
          Begin
            NavEdit.VisibleButtons := NavEdit.VisibleButtons + [nbEDelete];
            Exit;
          End;
        if ( ls_Action = CST_LEON_ACTION_REF_ADD   )
        or ( ls_Action = CST_LEON_ACTION_REF_CLONE ) then
          Begin
            NavEdit.VisibleButtons := NavEdit.VisibleButtons + [nbEInsert];
            if ( NavEdit = Navigator )
            and assigned ( Grid ) Then
             p_SetComponentBoolProperty( Grid, CST_PROPERTY_READONLY, False );
            Exit;
          End;
        if  ( ls_Action = CST_LEON_ACTION_REF_PRINT )
        and ( DBSources.count > 0 )
         then
          Begin
            gbtn_PrintButton := TFWPrintSources.Create ( Self );
            with gbtn_PrintButton do
              Begin
                Width := 90;
                Left := Left - Width;
                Caption := gs_print;
              end;
            fpan_CreateAction ( gbtn_PrintButton, CST_COMPONENTS_BUTTON_PRINT, Self, FActionPanel );
            Exit;
          End;
       end;


end;

// procedure p_SetFieldActionsTemplatesProperties
// Setting the templates' actions
// anod_Action : Action node for buttons
// awin_Parent : Parent component

procedure TF_XMLForm.p_SetTemplatesProperties(const ai_counter : Integer;var afc_formcreate:TDoCreateFromXML);
var ls_Action   : String ;
    lwin_Last : TWinControl;
begin
 fwin_SetActionPanels;
 lwin_Last := nil;
 if gat_SomeTemplate = atTree
  Then lwin_Last := ftree_CreateTree(gwin_Parent,lwin_Last,ai_counter,afc_formcreate,nil )
 else if gat_SomeTemplate = atMap
  Then lwin_Last := fwin_tablesGoogleMap(gwin_Parent,lwin_Last,ai_counter,afc_formcreate,nil );
 if Assigned(lwin_Last) Then
  with lwin_Last do
    Begin
     if Parent.ControlCount < 2
      Then Align:=alClient
      Else Align:=alTop;
    end;

end;

procedure TF_XMLForm.p_ScruteComposantsFiche();
begin
end;

function TF_XMLForm.fb_setStructControl ( const afws_Source, afws_source2 : TFWTable; const anod_Field : TALXMLNode; const afd_Field1 : TFWFieldColumn; const acon_Control : TControl;var lcx_columnField: TDoCreateFromXML;var ai_FieldCounter : Integer ): Boolean;
Begin
 if assigned ( acon_Control ) Then
  Begin
    p_CreateArrayStructComponentsControls ( DBSources,afws_Source2,afd_Field1,anod_Field,acon_Control,lcx_columnField,ai_FieldCounter);
    p_LinkTables ( afws_Source,afws_source2 );
    Result :=True;
  End
 Else
  Result :=False;
end;
// procedure p_CreateField
// Creating the column components
// as_Table : Table Name
// anod_Field: Node field
// ai_FieldCounter : Field counter
//  ai_Counter : Column counter
// awin_Parent : Parent component
// ab_Column : Second editing column
// afws_Source : XML form Column
// afd_FieldsDefs : Field Definitions
procedure TF_XMLForm.p_CreateField ( const anod_Fields, anod_Field : TALXMLNode;
                                     const afws_Source : TFWSource ;
                                     var   anod_FieldImport  : TALXMLNode ;
                                     var   adoc_ClassImport : TALXMLDocument;
                                     var   acx_FormCreate : TDoCreateFromXML ;
                                     var   ai_FieldCounter : Longint ;
                                     const ab_SeparateIfTooMuch : Boolean = True);
var lcon_Control : TControl;
    lcon_controlResult : TPanel;
    ls_name, ls_group, ls_tab : String;
    lnod_OriginalNode,
    lnod_TemplateNode : TALXMLNode;
    lfd_Field1, lfd_Field2 : TFWFieldColumn;
Begin
 lcon_Control := nil;
 lcon_controlResult := nil;
 ls_name := '';
 ls_group := '';
 ls_tab := '';
 lnod_TemplateNode := nil;
 lnod_OriginalNode := nil;
 fb_CreateField ( anod_Fields, anod_Field,
                  afws_Source,
                  nil,
                  lcon_Control,
                  lcon_controlResult,
                  ls_name, ls_group, ls_tab,
                  anod_FieldImport,
                  lnod_OriginalNode,
                  lnod_TemplateNode,
                  adoc_ClassImport,
                  lfd_Field1, lfd_Field2,
                  ai_FieldCounter,
                  acx_FormCreate,
                  ab_SeparateIfTooMuch );

end;

// function fb_CreateField
// Creating the column components
// anod_Fields, anod_Field : Fields and a field
// awin_Parent : Parent component
// ai_FieldCounter : Field counter
//  ai_Counter : Column counter
// ab_Column : Second editing column
// afws_Source : XML form Column
// afd_FieldsDefs : Field Definitions
// result : Node is array or struct
function TF_XMLForm.fb_CreateField ( const anod_Fields, anod_Field : TALXMLNode;
                                     const afws_Source : TFWSource ;
                                     const awin_parent : TWinControl;
                                     var  acon_Control : TControl;
                                     var acon_controlResult : TPanel;
                                     var as_name, as_group, as_tab : String;
                                     var   anod_FieldImport, anod_OriginalNode, anod_TemplateNode  : TALXMLNode;
                                     var   adoc_ClassImport : TALXMLDocument;
                                     var   afd_Field1, afd_Field2 : TFWFieldColumn;
                                     var   ai_FieldCounter : Longint ;
                                     var   acx_FormCreate : TDoCreateFromXML ;
                                     const ab_SeparateIfTooMuch : Boolean = True ):Boolean;

// procedure p_CreateArrayStructComponents
 // Creating groupbox of struct with controls
 procedure p_CreateArrayStructComponents;
 var li_k, li_l, li_FieldCounter : LongInt ;
     lcx_columnField : TDoCreateFromXML;
     lwin_last : TControl;
     lnod_afield,lnod_afieldImport,
     lnod_FieldsNode : TALXmlNode;
     lb_fieldFound: Boolean;
     ldoc_ClassImport : TALXMLDocument;
     lfws_Source2 : TFWTable;
 begin
   Result := False;
   lfws_Source2 := nil;
   anod_OriginalNode := fnod_GetNodeFromTemplate(anod_Field);
   if anod_Field <> anod_OriginalNode Then
     Begin
      lcx_columnField := [cxFieldFound];
      lfws_Source2 := fwt_getOptionalStructTableBegin ( DBSources,lfws_Source2,lcx_columnField,ai_FieldCounter,afd_Field1,anod_Field,anod_OriginalNode, True, True, True );
      if assigned ( lfws_Source2 ) Then
         if fb_setStructControl ( afws_Source, lfws_Source2,anod_Field,afd_Field1,acon_Control,lcx_columnField,ai_FieldCounter)
          Then
           Exit;
     end;

   li_FieldCounter := 0 ;
   //ls_NodeId := anod_Field.Attributes[CST_LEON_ID];
   anod_OriginalNode := fnod_GetNodeFromTemplate(anod_Field);
   ldoc_ClassImport := nil;
   if anod_OriginalNode.HasChildNodes then
     for li_k := 0 to anod_OriginalNode.ChildNodes.Count - 1 do
       Begin
         lnod_FieldsNode := anod_OriginalNode.ChildNodes [ li_k ];
         if lnod_FieldsNode.NodeName = CST_LEON_NAME then
           Begin
             afd_Field1.Caption:=fs_GetLabelCaption(lnod_FieldsNode.Attributes[CST_LEON_VALUE]);
             Continue;
           End;
         if (   anod_OriginalNode.NodeName = CST_LEON_STRUCT )
         and anod_OriginalNode.ChildNodes [ li_k ].HasChildNodes then
           Begin
             lcx_columnField := lcx_columnField-[cxDoubleColumn];
             lwin_last:=nil;
             if lnod_FieldsNode.NodeName = CST_LEON_FIELDS Then
               Begin
                 for li_l := 0 to lnod_FieldsNode.ChildNodes.Count - 1 do
                   Begin
                     lnod_afield := lnod_FieldsNode.ChildNodes [ li_l ];
                     if anod_Field <> anod_OriginalNode Then
                       lwin_last:=fpan_CreateFieldComponentAndProperties ( lnod_FieldsNode,lnod_afield,
                                                                           lfws_Source2 as TFWSource,
                                                                           lnod_afieldImport,
                                                                           ldoc_ClassImport,
                                                                TWinControl(acon_controlResult), lwin_last,
                                                                li_FieldCounter,
                                                                lcx_columnField, False )
                      else
                       lwin_last:=fpan_CreateFieldComponentAndProperties ( lnod_FieldsNode,lnod_afield,
                                                                           afws_Source,
                                                                           lnod_afieldImport,
                                                                           ldoc_ClassImport,
                                                                TWinControl(acon_controlResult), lwin_last,
                                                                ai_FieldCounter,
                                                                acx_FormCreate, False );
                   end;
                 FreeAndNil(ldoc_ClassImport);
               end
              Else
                 // The parent parameter is a var : so do not want to change it in the function
                 if anod_Field <> anod_OriginalNode Then
                  Begin
                   lnod_afield := lnod_FieldsNode.ChildNodes [ li_l ];
                   lwin_last:=fpan_CreateFieldComponentAndProperties ( lnod_FieldsNode,lnod_afield,
                                                                       lfws_Source2 as TFWSource,
                                                                       lnod_afieldImport,
                                                                       ldoc_ClassImport,
                                                            TWinControl(acon_controlResult), lwin_last,
                                                            li_FieldCounter, lcx_columnField, False )
                  end
                  else
                    Begin
                     lnod_afield := lnod_FieldsNode.ChildNodes [ li_l ];
                     lwin_last:=fpan_CreateFieldComponentAndProperties ( lnod_FieldsNode,lnod_afield,
                                                                         afws_Source,
                                                                         lnod_afieldImport,
                                                                         ldoc_ClassImport,
                                                              TWinControl(acon_controlResult), lwin_last,
                                                              ai_FieldCounter,
                                                              acx_FormCreate, False );
                    end;
             FreeAndNil(ldoc_ClassImport);
           end;
       end;
   if Assigned(acon_controlResult) then
   with lwin_last do
    acon_controlResult.ClientHeight := Top +Height; // do not forget groupbox caption
 end;
var lb_column : Boolean;
Begin
  Result := False;
  // adding not local field
  afd_Field1 := afws_Source.FieldsDefs.Add ;

  // Creating field with class template
  if fb_createFieldID ( True, anod_Field, afd_Field1, gcx_FormCreating, ai_FieldCounter,True)
  Then
    Begin
     if anod_Field.HasAttribute(CST_LEON_ID)
      Then as_name:=anod_Field.Attributes[CST_LEON_ID]
      Else as_name:=anod_Field.Attributes[CST_LEON_IDREF];
    end
   Else
    Begin
      afws_Source.FieldsDefs.Delete(afd_Field1.Index);
      Exit;
    end;
  // Can be idref or template
  if cxTemplateClass in gcx_FormCreating Then
   Begin
     if gxml_classTemplate = nil Then
      p_FindTableOrigin(afws_Source,DBSources,Self,gxml_classTemplate);// global var for best results
       if assigned ( gnod_classTemplate )  // global var for best results
        Then anod_TemplateNode:=fnod_GetFieldNode ( gnod_classTemplate, afd_Field1.FieldName )  // class template
        Else anod_TemplateNode:=fnod_GetFieldNode ( gxml_classTemplate, gnod_classTemplate, afd_Field1.FieldName );
     if Assigned(anod_TemplateNode)
      Then afd_Field2:=ff_GetTemplateField ( DBSources, afws_Source, afd_Field1.FieldName, anod_Fields, anod_Field, anod_TemplateNode)
      Else
      if anod_Field.HasAttribute(CST_LEON_TEMPLATE)
       Then
        Begin
          // root template
         anod_TemplateNode:=fnod_GetFieldNode ( gxdo_RootXML, anod_Field.Attributes[CST_LEON_TEMPLATE] );
         afd_Field2:=ff_GetTemplateField ( DBSources, afws_Source, anod_Field.Attributes[CST_LEON_TEMPLATE], anod_Fields, anod_Field, anod_TemplateNode);
        End;
   end
  Else // field template
  if anod_Field.NodeName = CST_LEON_ARRAY Then   // to do
   Begin
    Result := True;
    Exit;
   end
  else
   if anod_Field.HasAttribute(CST_LEON_TEMPLATE) Then
    if anod_Field.NodeName = CST_LEON_STRUCT Then
     Begin
        Result := True;
        if assigned ( awin_parent ) Then
          acon_Control := fgrb_CreateGroupBox(awin_parent,CST_COMPONENTS_GROUPBOX_BEGIN + anod_Field.Attributes[CST_LEON_ID] + IntToStr(ai_FieldCounter),Self,alTop);
        p_CreateArrayStructComponents;
        // set top of groupbox
        lb_column := cxDoubleColumn in acx_FormCreate;
        //set left and width
        if lb_column
         Then acx_FormCreate:=acx_FormCreate+[cxDoubleColumn]
         Else acx_FormCreate:=acx_FormCreate-[cxDoubleColumn];
        p_FieldIsNotAKey( afd_Field1 );
        // Quitting because having created component
        Result := True;
        Exit;
       end
      Else
       Begin
        anod_TemplateNode:=fnod_GetFieldNode ( gxdo_RootXML, anod_Field.Attributes[CST_LEON_TEMPLATE] );
        afd_Field2:=ff_GetTemplateField ( DBSources, afws_Source, anod_Field.Attributes[CST_LEON_TEMPLATE], anod_Fields, anod_Field, anod_TemplateNode);
       End
     Else
      afd_Field2:=nil;

  if assigned ( anod_TemplateNode )
   Then fb_setFieldType(DBSources,afws_Source,afd_Field2,anod_Fields,anod_TemplateNode,anod_FieldImport,as_Group, as_tab,
                        gxml_classTemplate,adoc_ClassImport,ai_FieldCounter,acx_FormCreate,False,Self)
   Else fb_setFieldType(DBSources,afws_Source,afd_Field1,anod_Fields,anod_Field,anod_FieldImport,as_Group, as_tab,
                        gxml_classTemplate,adoc_ClassImport,ai_FieldCounter,acx_FormCreate,False,Self);

end;

// procedure p_CreateFieldComponentAndProperties
// Creating the column components
// as_Table : Table Name
// anod_Field: Node field
// ai_FieldCounter : Field counter
//  ai_Counter : Column counter
// awin_Parent : Parent component
// ab_Column : Second editing column
// afws_Source : XML form Column
// afd_FieldsDefs : Field Definitions
function TF_XMLForm.fpan_CreateFieldComponentAndProperties ( const anod_Fields : TALXMLNode;
                                                                   anod_Field : TALXMLNode;
                                                             const afws_Source : TFWSource ;
                                                             var   anod_FieldImport  : TALXMLNode;
                                                             var   adoc_ClassImport : TALXMLDocument;
                                                             var   awin_parent: TWinControl;
                                                                   awin_last : TControl;
                                                             var   ai_FieldCounter : Longint ;
                                                             var   acx_FormCreate : TDoCreateFromXML ;
                                                             const ab_SeparateIfTooMuch : Boolean = True ):TPanel;
var llab_Label  : TFWLabel;
    lct_ComponentType  : TComponentType;
    lffd_ColumnFieldDef1, lffd_ColumnFieldDef2 : TFWFieldColumn;
    lnod_TemplateNode  : TALXMLNode;
    lnod_OriginalNode : TALXmlNode;
    lxfc_ButtonCombo : TXMLFillCombo;
    ls_name, ls_Group, ls_tab : String;
    FPage : TCustomTabControl;
    acon_Control : TControl ;
    ls_temp : String;
    // procedure p_SetControl
    // set control from xml
    procedure p_SetControl( var apan_Panel : TPanel;
                            const afws_ADatasource : TFWSource ;
                            const affd_ColumnFieldDef : TFWFieldColumn;
                            const acon_Control : TControl ;
                            const anod_FieldTemplate : TALXMLNode;
                            const ai_FieldCounter : Integer ;
                            var acx_column : TDoCreateFromXML);
    var lb_column : boolean;
        ls_namecontrol : String;
    Begin
      // The created control must be set and placed

      // set name of control
      ls_namecontrol := IntToStr(ai_FieldCounter)+'_'+anod_Field.NodeName+awin_Parent.ClassName+'_';
      apan_panel := fpan_CreatePanel(awin_Parent,'pan_' +ls_namecontrol+IntToStr(afws_ADatasource.Index), Self, alTop);
      with apan_Panel do
       Begin
        Height:=acon_Control.Height;
        if assigned ( awin_Last ) Then
          Top   :=awin_Last.Top+awin_Last.Height+1;
       end;
      p_setControlNameAndTag( acon_Control,lowercase ( copy ( acon_Control.ClassName, 2,4))+ ls_namecontrol, ls_name, apan_Panel, ai_FieldCounter, afws_ADatasource.Index);
      if Assigned(lxfc_ButtonCombo)
       Then with lxfc_ButtonCombo do
        Begin
         Parent:=apan_Panel;
         Align:=alRight;
        end;
      if acon_Control is TExtImage Then
      with acon_Control as TExtImage do
       Begin
        ClickAdd := True;
        Stretch  := True;
        Proportional:=True;
       End
      Else
       if acon_Control is TExtOperation Then
        with acon_Control as TExtOperation, affd_ColumnFieldDef do
         Begin
           if pos ( CST_SQL_ALL, Formula ) > 0 Then
            Begin
             Operation := aoMultiple;
             ls_temp := CST_SQL_ALL;
            end
           else if pos ( '+', Formula ) > 0 Then
            Begin
             Operation := aoPlus;
             ls_temp := '+';
            end
           else if pos ( '-', Formula ) > 0 Then
            Begin
             Operation := aoMinus;
             ls_temp := '-';
            end
           else if pos ( '/', Formula ) > 0 Then
            Begin
             Operation := aoDivide;
             ls_temp := '/';
            end
           else if pos ( ' e ', Formula ) > 0 Then
            Begin
             Operation := aoExponent;
             ls_temp := ' e ';
            end
           else if pos ( ' l ', Formula ) > 0 Then
            Begin
             Operation := aoLogN;
             ls_temp := ' l ';
            end;
           Operated1 := findByNamePos ( fs_getControlNamePos  ( 'con_NUMBER',
                                     Trim ( copy ( Formula, 1, pos ( ls_temp, Formula ) - 1 )))) as TCustomEdit;
           Operated2 := findByNamePos ( fs_getControlNamePos  ( 'con_NUMBER',
                                     Trim ( copy ( Formula, pos ( ls_temp, Formula ) + 1, length ( Formula ) - 1)))) as TCustomEdit;
         end;
      lb_column := cxDoubleColumn in acx_column;
      // placing top of control
{      if awin_parent is TGroupBox // can be a structured field in another table
       Then p_setFieldComponentTop ( acon_Control, awin_last, lb_Column )
       Else p_setFieldComponentTop ( acon_Control, ai_LastPanelColumnHeight,ai_LastPanelFieldsHeight-ai_LastPanelColumnHeight, lb_Column );
 }
      // optional data link
      p_setFieldComponentData   ( acon_Control, afws_ADatasource, affd_ColumnFieldDef, lct_ComponentType );
      p_setFieldComponentFilter ( acon_Control, anod_Field, anod_FieldImport, affd_ColumnFieldDef, lct_ComponentType );

      // adding optional label
      fpan_setFieldComponentProperties ( llab_Label, acon_Control, anod_Field, anod_FieldTemplate, apan_Panel, ls_name, awin_Parent, acx_FormCreate, afws_ADatasource.Index, lb_Column, affd_ColumnFieldDef );

      // placing left of control
      if lb_column
       Then acx_column:=acx_column+[cxDoubleColumn]
       Else acx_column:=acx_column-[cxDoubleColumn];
      if lct_ComponentType in [ ctLocal, ctFilter ] Then
       Begin
         // setting name of no data control sets text property
         p_SetComponentProperty(acon_Control,CST_PROPERTY_TEXT,'');
         // no local definition
         afws_ADatasource.FieldsDefs.Delete(affd_ColumnFieldDef.Index);
       end;
    end;

     procedure p_grouping( const anod_FieldsGrouping : TALXMLNode; const  anod_FieldGrouped : TALXMLNode); // grouping edits
    var li_i, li_j : Integer;
        lnod_Properties : TALXmlNode;
        ls_grouping : String;
    Begin
      if gs_group <> ls_Group Then
       Begin
         ls_grouping := '' ;
         if gi_group = -1 Then
          Begin // restoring gi_group after using it
           gi_group:=0;
           for li_i:=0 to anod_FieldsGrouping.ChildNodes.Count-1 do
            Begin
              lnod_Properties := anod_FieldsGrouping.ChildNodes [ li_i ];
              if lnod_Properties.HasChildNodes Then
               for li_j := 0 to lnod_Properties.ChildNodes.Count - 1 do
                 with lnod_Properties.ChildNodes [ li_j ] do
                  if NodeName = CST_LEON_GROUP Then
                    Begin
                      if ls_grouping <> Attributes[CST_LEON_VALUE] Then
                       inc(gi_group);
                      ls_grouping := Attributes[CST_LEON_VALUE];
                      Break;
                    end;
            end;
           gi_groupsMiddle:=(gi_group+1) div 2;
           gi_group:=0;
          end
         Else
          if  (ls_group>'')
          and (gi_group = gi_groupsMiddle)
          and (awin_parent = gpan_Left) Then
            Begin
              gwin_Parent:=gpan_Right;
              awin_parent:=gpan_Right;
            end;
         if ls_Group > ''  Then
          Begin
            inc(gi_group);
            gs_group:=ls_Group;
          end;
       End;
    end;

    function fct_GetComponentType ( const affd_Field : TFWFieldColumn ): TComponentType;
    Begin
      if affd_Field.ColLocal Then
       Begin
         if anod_FieldImport = nil
          Then Result:=ctLocal
          Else Result:=ctFilter;
       end
      Else Result:=ctDB;
    end;

    // procedure p_CreateComponents
    // Creating the component and setting data link

    function fb_CreateComponents ( var apan_Panel : TPanel ) : Boolean ;
      var lb_column : Boolean;
          lnod_AField : TALXmlNode;

     Begin
      lnod_TemplateNode := nil;
      Result := False;
      if fb_CreateField ( anod_Fields,anod_Field,afws_Source,
                       awin_parent,acon_Control,apan_Panel,
                       ls_name,ls_Group,ls_tab,anod_FieldImport,
                       lnod_OriginalNode,lnod_TemplateNode,
                       adoc_ClassImport,lffd_ColumnFieldDef1,
                       lffd_ColumnFieldDef2,ai_FieldCounter,
                       acx_FormCreate,ab_SeparateIfTooMuch)
        Then // if component is array or struct so exit
         Exit;
      if assigned ( lnod_TemplateNode )
       Then lct_ComponentType:=fct_GetComponentType ( lffd_ColumnFieldDef2 )
       Else lct_ComponentType:=fct_GetComponentType ( lffd_ColumnFieldDef1 );
     lb_column := cxDoubleColumn in acx_FormCreate;

      if assigned ( lnod_TemplateNode )
      and ( anod_Field.NodeName <> CST_LEON_STRUCT )
       Then p_grouping(lnod_TemplateNode.ParentNode,lnod_TemplateNode)
       Else p_grouping(anod_Fields,anod_Field);
      Result := True;

      if Assigned(anod_FieldImport)
       Then lnod_AField := anod_FieldImport
       Else lnod_AField := anod_Field;
      if Assigned(lffd_ColumnFieldDef2)
       Then Result := fb_CreateComponentAndProperties ( acon_Control,lnod_AField,lffd_ColumnFieldDef2,afws_Source,
                                                        awin_parent,lxfc_ButtonCombo,ls_name,lct_ComponentType,
                                                        ai_FieldCounter,acx_FormCreate)
       Else Result := fb_CreateComponentAndProperties ( acon_Control,lnod_AField,lffd_ColumnFieldDef1,afws_Source ,
                                                        awin_parent,lxfc_ButtonCombo,ls_name,lct_ComponentType,
                                                        ai_FieldCounter,acx_FormCreate );

      // filtering finished controls : Must be a simple control
      if not assigned ( acon_Control )
      or ( acon_Control is TDBGroupView )
      or ( acon_Control is TCustomDBGrid ) then
        Exit;


      if assigned ( lffd_ColumnFieldDef2 )
       Then  p_SetControl ( apan_Panel, afws_Source , lffd_ColumnFieldDef2, acon_Control, lnod_TemplateNode, ai_FieldCounter, acx_FormCreate )
       Else  p_SetControl ( apan_Panel, afws_Source , lffd_ColumnFieldDef1, acon_Control, nil              , ai_FieldCounter, acx_FormCreate );

      ScaleDPIControl(Self,acon_Control);
      if Assigned(apan_Panel) then
        ScaleDPIControl(Self,apan_Panel);
    end;
begin
  Result := nil;
  lffd_ColumnFieldDef1:=nil;
  lffd_ColumnFieldDef2:=nil;

  // Initing fb_CreateComponents
  lxfc_ButtonCombo := nil;
  acon_control := nil;
  // Placing the created control
  if fb_CreateComponents ( Result )  Then
    if assigned ( Result ) Then
      Begin

        // setting width of control amd parent
        p_SetControlAndParentWidth ( Result, awin_parent );
        // setting parent widths
        if not ( awin_Parent is TCustomGroupBox )
         Then
          Begin
            // next ab_column
           ResizeScrollBox(Result);
          end ;

      end;

end;
function TF_XMLForm.fwin_tablesGoogleMap(var awin_parent: TWinControl; awin_last: TControl;
  const ai_FieldCounter: Longint; var acx_FormCreate: TDoCreateFromXML;
  const afws_Source: TFWSource; const ab_SeparateIfTooMuch: Boolean
  ): TPanel;
Begin
  Result:=fpan_CreatePanel(awin_parent,'PanelGoogleMap'+IntToStr(ai_FieldCounter),Self,alClient);
end;

function TF_XMLForm.ftree_CreateTree(var awin_parent: TWinControl; awin_last: TControl;
  const ai_FieldCounter: Longint; var acx_FormCreate: TDoCreateFromXML;
  const afws_Source: TFWSource; const ab_SeparateIfTooMuch: Boolean
  ): TCustomVirtualStringTree;
    procedure p_setTablesParameters;
    var li_i : Integer;
        ls_name, ls_end : String;
        lxml_Class : TALXMLDocument ;
        LTable : TFWTable ;
      procedure p_SetTable ;
      Begin
        with LTable as TFWTableTree do
          try
            IsMain     := True;
            if Length(TableXML)=Length(CST_LEON_PARAMETER_CLASSINFO)   // setting level from parameter
             Then Level:=1
             Else Level:=Length(copy(TableXML,Length(CST_LEON_PARAMETER_CLASSINFO)+1,Length(TableXML)))+1;
            ft_CreateComponents ( (Result as TTablesDBTree).Tables,ls_name,Table,lxml_Class,Self,
                           TOnExecuteFieldNode(p_LinkTablesRelations),
                           nil,
                           nil,[cxSkipClass,cxCreateDS],'',ls_end);

          finally
            lxml_Class.Free;
          end
      end;

     procedure p_TransformRealName;
      var li_k : Integer;
      Begin
        ls_end:='';
        for li_k:=Length(ls_name) to 1 do
         if IsNumber(ls_name[li_k]) Then
           AppendStr(ls_end,ls_name[li_k])
          Else
          Begin
           SetLength(ls_name,li_k);
           Exit;
          end;

      end;

    Begin
     with Result as TTablesDBTree,ga_Functions[gi_SomeFunction] do
      try
       if AFile > '' Then
        Begin
         LTable:= Tables.Add;
         LTable.TableXML   := AFile;
         ls_name    :=AFile;
         ls_end     := '0';
         p_SetTable;
        end;
       for li_i:= 0 to high(Parameters) do
        Begin
         ls_name := (Parameters [ li_i ].Name);
         if pos ( CST_LEON_PARAMETER_CLASSINFO, ls_name ) = 1 Then
          with Parameters [ li_i ] do
            if assigned(Tables.TableByNameXML(Value))
              Then
               Begin
                p_TransformRealName;
                LTable:=Tables.TableByNameXML(Value);
                p_SetTable;
               end
              Else
                Begin
                 LTable:= Tables.Add;
                 p_TransformRealName;
                 LTable.TableXML   := Value;
                 p_SetTable;
                end;
        end;
     finally
     end;
    end;


begin
  Result:=TTablesDBTree.Create(Self);
  Result.Parent:=awin_parent;
  Result.Name:='vtt_TablesTree'+IntToStr(ai_FieldCounter);
  with Result as TTablesDBTree do
   Begin
     p_setTablesParameters;
     SetSQL;
     DBOptions:=[dboTrackActive];
   end;
end;

function TF_XMLForm.fb_CreateComponentAndProperties ( var acon_Control : TControl;
                                                      const anod_Field: TALXMLNode;
                                                      const affd_ColumnFieldDef : TFWFieldColumn;
                                                      const afws_Source : TFWSource ;
                                                      const   awin_parent : TWinControl;
                                                      var   axfc_ButtonCombo : TXMLFillCombo;
                                                      const as_name : String;
                                                      var   act_ComponentType  : TComponentType;
                                                      const   ai_FieldCounter : Longint ;
                                                      const   acx_FormCreate : TDoCreateFromXML  ):Boolean;
   function fb_ContinueData ( const affd_ColumnFieldDef : TFWFieldColumn ) : Boolean;
    Begin
      with affd_ColumnFieldDef do
       Result := (ColUnique and AutoIncField and ColHidden)
              or ((cxMainOnly in acx_FormCreate) and (act_ComponentType in [ctLocal,ctFilter] ));
    End;
             {
   // procedure p_CreateArrayStructComponents
   // Creating groupbox of 11 relationship with controls
   procedure p_CreateRelationBoxComponents ( const awin_control : TWinControl; const afw_RelationSource : TFWSource; const affd_ColumnFieldDef : TFWFieldColumn);
     var lwin_parent : TWinControl;
         lxml_Class : TALXMLDocument;
     begin
       lwin_parent := gwin_Parent;
       gwin_Parent := awin_control;
       gpan_ControlLast   := nil;
       lxml_Class := Nil;
       // there is a class in the box
       with affd_ColumnFieldDef.Relation.TablesDest[0] do
        try
         ft_CreateComponents ( DBSources,TableXML,Table,lxml_Class,Self,
                             TOnExecuteFieldNode(p_OnCreateParentAndFieldsComponent), nil, nil,[]);
         p_LinkTables ( afws_Source, DBSources.TableByName(Table));

        finally
          lxml_Class.Free;
        end;
      if assigned ( gpan_ControlLast ) Then
      with gpan_ControlLast do
       awin_control.ClientHeight := Top +(Height + CST_CONTROLS_INTERLEAVING)*2; // do not forget groupbox caption
      gwin_Parent := lwin_parent;
     end;
              }
   // function fcon_CreateFieldOrLocalComponent
   // create data and local component.
   function fcon_CreateFieldOrLocalComponent ( const affd_ColumnFieldDef : TFWFieldColumn; const anod_ANodeField : TALXMLNode):TControl;
    var ls_MimeType : String;
        lmt_MimeType : TMimeType;
     Begin
       if anod_ANodeField.HasAttribute(CST_LEON_MIMETYPES)
        Then ls_MimeType:=anod_ANodeField.Attributes[CST_LEON_MIMETYPES]
        Else ls_MimeType:='';
       lmt_MimeType:=mtNone;
       if ls_MimeType = CST_LEON_MIME_IMAGE then lmt_MimeType:=mtImage;
       Result := fcon_CreateAFieldOrLocalComponent ( affd_ColumnFieldDef, Self, act_ComponentType, lmt_MimeType );
       if anod_ANodeField.HasAttribute(CST_LEON_DIRECTORY)
        Then p_SetComponentProperty(Result,'FilesDir',fs_LeonFilter(anod_ANodeField.Attributes[CST_LEON_DIRECTORY]));
        if  ( Result = nil ) then
         Begin
           MyShowmessage ( Gs_NoComponentToCreate + affd_ColumnFieldDef.FieldName +'.' );
           gb_Unload := True;
         End;
     end;
  procedure p_CreateControl;
   var lxc_KeepingFormCreating:TDoCreateFromXML;
    Begin
       if cxIsRelation in acx_FormCreate // 1N NN relationships
       Then
        Begin
         acon_Control := ffwc_getRelationComponent(DBSources,afws_source,awin_parent,FPanelMain,affd_ColumnFieldDef,axfc_ButtonCombo,as_name,act_ComponentType,Self,ai_FieldCounter);
{         if acon_Control is TCustomGroupBox Then
          try
           lxc_KeepingFormCreating := gcx_FormCreating;
           gcx_FormCreating:=gcx_FormCreating-[cxTemplateClass];
           //p_CreateRelationBoxComponents(acon_Control as TWinControl, afws_Source , affd_ColumnFieldDef);

          finally
            gcx_FormCreating := lxc_KeepingFormCreating;
          End;}
        end
       else
         acon_Control := fcon_CreateFieldOrLocalComponent ( affd_ColumnFieldDef, anod_Field );

    end;

Begin
  p_SetFieldSelect ( affd_ColumnFieldDef, act_ComponentType );

  Result := False;

  if gat_Template = atmultiPageTable
   Then Exit;
  if fb_ContinueData ( affd_ColumnFieldDef )
    Then
     Exit;

  // create control
  p_CreateControl;

  Result := True;
end;

// procedure p_CreateFormComponents
// Create a form from XML File
// as_XMLFile : XML File
// as_Name : Name of form
// awin_Parent : Parent component
// ai_Counter : The column counter for other XML File
procedure TF_XMLForm.p_CreateFormComponents ( const as_XMLClass,as_Name : String ; awin_Parent : TWinControl );
var lxml_Class : TALXMLDocument;
    lcx_FormCreate : TDoCreateFromXML;
begin
  // For actions at the end of xml file
   gi_LastFormFieldsHeight := 0;
   gwin_Parent:=awin_Parent;
   gpan_ControlLast := nil;
   lxml_Class   := nil;
   lcx_FormCreate := [cxCreateDS];
  if gat_SomeTemplate in [atTree,atMap] Then
    lcx_FormCreate := lcx_FormCreate+[cxMainOnly];
   try
     ft_CreateComponents ( DBSOurces,as_XMLClass,as_Name,lxml_Class,Self,
                          TOnExecuteFieldNode(p_OnCreateParentAndFieldsComponent),
                          TOnExecuteActionNode(p_OnButtonsComponents),
                          TOnExecuteNode(p_OncolumnNameNode ),lcx_FormCreate);
   finally
     lxml_Class.Destroy;
   end;
end;



// overrided procedure BeforeCreateFrameWork
// Creating invisible component and setting it
// Sender : needed
procedure TF_XMLForm.BeforeCreateFrameWork(Sender: TComponent);
begin
  if not assigned ( gfin_FormIni )
   Then gfin_FormIni := TOnFormInfoIni.Create(Self);
  gfin_FormIni.OnReadComponent:=p_onIniComponent;
  gfin_FormIni.SaveEdits   := [feTGrid,feTVirtualTrees,feTListView];
  gfin_FormIni.SaveForm    := [sfSameMonitor,sfSavePos,sfSaveSize,sfSaveSizes];
  gfin_FormIni.Name := CST_COMPONENTS_FORMINI;
  gfin_FormIni.Options := [loAutoUpdate,loFreeIni];
  DBCloseMessage := True;
end;



// procedure p_CreateArrayStructComponentsControls
// Creating groupbox with controls
procedure TF_XMLForm.p_CreateArrayStructComponentsControls ( const ADBSources : TFWTables;
                                                             const ADBSource : TFWTable;
                                                             const affd_ColumnFieldDef : TFWFieldColumn;
                                                             const anod_Field: TALXMLNode;
                                                             const acon_control: TControl;
                                                             var acx_FieldColumn: TDoCreateFromXML;
                                                             var ai_Fieldcounter: Longint);
var li_k, li_i, li_FieldCounter : LongInt ;
    lcx_columnFieldFound : TDoCreateFromXML;
    lnod_FieldsNode, lnod_FieldNode, lnod_FieldImport,
    lnod_OriginalNode : TALXmlNode;
    lwin_Parent : TWinControl;
    ldoc_ClassImport : TALXMLDocument;

begin
  // in struct node
  lnod_OriginalNode := fnod_GetNodeFromTemplate(anod_Field);
  lcx_columnFieldFound := [];
  lcx_columnFieldFound := lcx_columnFieldFound-[cxDoubleColumn];
  ldoc_ClassImport := nil;
  if lnod_OriginalNode.HasChildNodes then
   try
    for li_k := 0 to lnod_OriginalNode.ChildNodes.Count - 1 do
      Begin
        lnod_FieldsNode := lnod_OriginalNode.ChildNodes [ li_k ];
        if lnod_FieldsNode.NodeName = CST_LEON_NAME then
          p_SetComponentProperty(acon_control,CST_PROPERTY_CAPTION,fs_GetLabelCaption(lnod_FieldsNode.Attributes[CST_LEON_VALUE]));
        if lnod_FieldsNode.NodeName = CST_LEON_FIELDS then
         Begin
          gpan_ControlLast:=nil;
          lcx_columnFieldFound := lcx_columnFieldFound + [cxFieldFound];
          li_FieldCounter := 0 ;
          lwin_Parent   := gwin_Parent;
          gwin_Parent   := acon_control as TWinControl;
          for li_i := 0 to lnod_FieldsNode.ChildNodes.Count - 1 do
             Begin
               lnod_FieldNode:= lnod_FieldsNode.ChildNodes [ li_i ];
               p_OnCreateParentAndFieldsComponent (ADBSources,ADBSource,lnod_FieldsNode,lnod_FieldNode,lnod_FieldImport,ldoc_ClassImport,lcx_columnFieldFound,li_FieldCounter);
             end;
          gwin_Parent := lwin_Parent;
         end;
      end;

   finally
     FreeAndNil(ldoc_ClassImport);
   end;
  if Assigned(acon_control)
  and assigned ( gpan_ControlLast ) Then
   with gpan_ControlLast do
    acon_control.ClientHeight := Top + Height; // do not forget groupbox caption
end;



{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_TXMLForm );
{$ENDIF}
end.


